!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! GEEARP-VERSION 0.0.0, August 2006
! Software for the paper "Robust Multipoint Simultaneous Identical-by-Descent Mapping for Two Linked Loci" 
! Author: Wan-Yu Lin and Daniel J. Schaid
! Start Date: July 29, 2006 (Sat)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


PROGRAM arp

  IMPLICIT NONE

  INTEGER, PARAMETER                            :: DP = selected_real_kind(33)
  INTEGER, PARAMETER                            :: maxiter=50
  INTEGER, PARAMETER                            :: maxiter1=50    ! for unconstrained model
  INTEGER                                       :: initest
  INTEGER                                       :: ini
  INTEGER                                       :: NN             ! unknown parameters need to be solved
  INTEGER                                       :: typerel(5)     ! the number of the four kinds of ARPs. Order: FS, HS, FC, GG, AP
  INTEGER                                       :: nrow_datfile
  INTEGER                                       :: nrow_pedfile   ! the number of individuals 
  INTEGER                                       :: nrow_postibd
  INTEGER                                       :: n_location     ! the number of locations
  INTEGER                                       :: InputStatus
  INTEGER                                       :: InputStatus1
  INTEGER                                       :: n_cov, ncov, couinf
  INTEGER                                       :: i, j, iter, cou, k, l, tmp, j1, j2, k1, k2, cc, ss, mm
  INTEGER                                       :: arpno
  INTEGER                                       :: FS, HS, FC, GP, AP
  INTEGER                                       :: bootno, bootco, arpbo, n, kind, temploc(1), n_fun
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: subfam, boot
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: indi
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: typereln
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: rel
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: familyn, familyntmp, familyb, nfamilyb
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: familynn, familynntmp
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: familyn1, familyn1tmp
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: familyn2, familyn2tmp
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: familyn3, familyn3tmp
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: familyn4, familyn4tmp
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: familyn5, familyn5tmp
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: reln, relb, se_cov
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: relnn
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: reln1
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: reln2
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: reln3
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: reln4
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: reln5
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: typeno
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: subfamilyn1
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: subfamilyn2
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: subfamilyn3
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: subfamilyn4
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: subfamilyn5
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: subfamtmp
  INTEGER, ALLOCATABLE, DIMENSION(:)            :: sample 
  INTEGER, ALLOCATABLE, DIMENSION(:,:)          :: sample_arpcovn

  REAL(KIND=DP)                                 :: prob(3)
  REAL(KIND=DP)                                 :: loca
  REAL(KIND=DP)                                 :: oldloca
  REAL(KIND=DP)                                 :: x1tmp
  REAL(KIND=DP)                                 :: x2tmp, tp, lower1, upper1, lower2, upper2
  REAL(KIND=DP)                                 :: lambda1, lambda2, sel1, sel2
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: ibdsum2, point, temppoint, bootCI
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: IBDS
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: ped1
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: IBDSn, IBDSb
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: IBDSnn
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: IBDSn1
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: IBDSn2
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: IBDSn3
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: IBDSn4
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: IBDSn5
  REAL(KIND=DP), PARAMETER                      :: eps=0.001_dp
  REAL(KIND=DP), PARAMETER                      :: eps1=0.000000001_dp
  REAL(KIND=DP), PARAMETER                      :: eps2=0.000000001_dp
  REAL(KIND=DP), PARAMETER                      :: eps3=0.05_dp
  REAL(KIND=DP)                                 :: oldx1, oldx2
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:)      :: x, fvec, xcon, uuu, avexb, mu
  REAL(KIND=DP)                                 :: sta, mar, uu, xini(3)
  REAL(KIND=DP), PARAMETER                      :: tolimit = 1.0_dp
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:)      :: IinvU
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:)      :: se
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:)      :: Initial
  REAL(KIND=DP)                                 :: TT(1,1)        ! the score statistic testing for homogeneity across different kind of ARPs
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:)      :: location, nlocation
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: varp
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:)      :: temp, covariate, covariateb
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:)    :: bound
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:)      :: x_lower
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:)      :: x_upper
  REAL(KIND=DP)                                 :: missing
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:,:)  :: arpcov, arpcovn, arpcovnn

      
!  CHARACTER(LEN=128)                            :: datfile
  CHARACTER(LEN=128)                            :: pedfile
  CHARACTER(LEN=128)                            :: postibd
  CHARACTER(LEN=1)                              :: MODEL
  CHARACTER(LEN=1)                              :: METHOD
  CHARACTER(LEN=1)                              :: constrained
  CHARACTER(LEN=1)                              :: BS
  CHARACTER(LEN=1)                              :: ifcov
  CHARACTER(LEN=1)                              :: FUN
  CHARACTER(LEN=20)                             :: countA
  CHARACTER(LEN=20)                             :: loc
  CHARACTER(LEN=20)                             :: oldloc
  CHARACTER(LEN=20)                             :: fam
  CHARACTER(LEN=20)                             :: oldfam
  CHARACTER(LEN=20), ALLOCATABLE, DIMENSION(:,:):: dat
  CHARACTER(LEN=20), ALLOCATABLE, DIMENSION(:,:):: ped
  CHARACTER(LEN=20), ALLOCATABLE, DIMENSION(:,:):: map
  CHARACTER(LEN=20)                             :: ibd(3), preibd(3)
  CHARACTER(LEN=20), ALLOCATABLE, DIMENSION(:,:):: ibdsum1
  CHARACTER(LEN=20)                             :: parent(2,2)
  CHARACTER(LEN=20)                             :: gparent(4,2)
  CHARACTER(LEN=20), ALLOCATABLE, DIMENSION(:)  :: family
  CHARACTER(LEN=20), ALLOCATABLE, DIMENSION(:)  :: familytmp
  CHARACTER(LEN=8), ALLOCATABLE, DIMENSION(:)   :: typename
  CHARACTER(LEN=20), ALLOCATABLE, DIMENSION(:)  :: cov


  OPEN(UNIT=38,FILE='Iter')


! fcn (NN, x, fvec, arpno, IBDSn, reln, eps, IinvU, familyn, n, t, m, varp, TT)

  WRITE(*,'(/,1X,A)') "***************************************************************"
  WRITE(*,*) "                                                                "
  WRITE(*,*) "              GEEARP-VERSION 0.0.0, 2006 August                 "
  WRITE(*,*) "           Multipoint IBD Mapping by GEE Approach               "
  WRITE(*,*) "               Wan-Yu Lin and Daniel J. Schaid                  "
  WRITE(*,*) "                                                                "
  WRITE(*,*) " The software does one of linkage analyses, estimating location "
  WRITE(*,*) " and genetic effect for one or two linked loci in a chromosomal "
  WRITE(*,*) " region, on the basis of full siblings, half siblings, first    "
  WRITE(*,*) " cousins, grandparent-grandchild pairs, and avuncular pairs.    "
  WRITE(*,*) " Although it provides analyses for the five types of ARPs,      "
  WRITE(*,*) " we would roughly suggest incorporating each kind of            "
  WRITE(*,*) " ARP into analysis when the number is greater than 20.          "
  WRITE(*,*) "                                                                "
  WRITE(*,*) "****************************************************************"


  WRITE(38,'(/,1X,A)') "***************************************************************"
  WRITE(38,*) "                                                                "
  WRITE(38,*) "              GEEARP-VERSION 0.0.0, 2006 August                 "
  WRITE(38,*) "           Multipoint IBD Mapping by GEE Approach               "
  WRITE(38,*) "               Wan-Yu Lin and Daniel J. Schaid                  "
  WRITE(38,*) "                                                                "
  WRITE(38,*) " The software does one of linkage analyses, estimating location "
  WRITE(38,*) " and genetic effect for one or two linked loci in a chromosomal "
  WRITE(38,*) " region, on the basis of full siblings, half siblings, first    "
  WRITE(38,*) " cousins, grandparent-grandchild pairs, and avuncular pairs.    "
  WRITE(38,*) " Although it provides analyses for the five types of ARPs,      "
  WRITE(38,*) " we would roughly suggest incorporating each kind of            "
  WRITE(38,*) " ARP into analysis when the number is greater than 20.          "
  WRITE(38,*) "                                                                "
  WRITE(38,*) "****************************************************************"
  

!  READ (*,'(A)') datfile
  READ (*,'(A)') pedfile
  READ (*,'(A)') postibd
  READ (*,'(A)') MODEL
  READ (*,'(A)') METHOD
  READ (*,'(A)') constrained
  READ (*,'(A)') BS
  READ (*,'(I)') bootno
  READ (*,'(I)') initest
  READ (*,'(I)') FS
  READ (*,'(I)') HS
  READ (*,'(I)') FC
  READ (*,'(I)') GP
  READ (*,'(I)') AP
!  READ (*,'(A)') ifcov
!  IF (ifcov .EQ. 'Y') THEN
!     READ (*,'(I)') ncov
!     ALLOCATE(cov(ncov))
!     DO i=1, ncov
!        READ(*,'(A)') cov(i)
!     END DO
!     READ (*,'(F)') missing
!     READ (*,'(A)') FUN
!  END IF
  

!  OPEN (UNIT=11, FILE=datfile, STATUS='OLD',POSITION='REWIND',ACTION='READ')
  OPEN (UNIT=12, FILE=pedfile, STATUS='OLD',POSITION='REWIND',ACTION='READ')
  OPEN (UNIT=13, FILE=postibd, STATUS='OLD',POSITION='REWIND',ACTION='READ')

! For simulation-unconstrained model

!  OPEN (UNIT=62, FILE='parameter',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=63, FILE='se',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=64, FILE='rovar',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=65, FILE='score',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=66, FILE='bootstrap',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=67, FILE='bootsamples',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=68, FILE='bootCI',POSITION='APPEND',ACTION='WRITE')

! For simulation-constrained model

!  OPEN (UNIT=72, FILE='parameter_con',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=73, FILE='se_con',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=74, FILE='rovar_con',POSITION='APPEND',ACTION='WRITE')

!  OPEN (UNIT=76, FILE='bootstrap_con',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=77, FILE='bootsamples_con',POSITION='APPEND',ACTION='WRITE')
!  OPEN (UNIT=78, FILE='bootCI_con',POSITION='APPEND',ACTION='WRITE')


  ! Read from the three input files and decide the array sizes

!  nrow_datfile = 0
!  n_cov = 0
!  DO 
!     READ (11,*,IOSTAT=InputStatus) countA
!     IF(InputStatus .EQ. 0) THEN
!        nrow_datfile=nrow_datfile+1
!     ELSE IF (InputStatus .LT. 0) THEN   ! end of file
!        EXIT
!     ELSE IF (InputStatus .GT. 0) THEN   ! Input Error
!        WRITE(*,*) 'Input error in datfile !'
!        STOP
!     END IF
!     IF (countA .EQ. 'E') THEN
!        nrow_datfile=nrow_datfile-1
!        EXIT
!     END IF
!     IF (countA .EQ. 'C') THEN
!        n_cov=n_cov+1
!     END IF
!  END DO


  nrow_pedfile = 0
  DO 
     READ (12,*,IOSTAT=InputStatus) countA
     IF(InputStatus .EQ. 0) THEN
        nrow_pedfile=nrow_pedfile+1
     ELSE IF (InputStatus .LT. 0) THEN   ! end of file
        EXIT
     ELSE IF (InputStatus .GT. 0) THEN   ! Input Error
        WRITE(*,*) 'Input error in pedfile !'
        STOP
     END IF
     IF (countA .EQ. 'end') THEN
        nrow_pedfile=nrow_pedfile-1
        EXIT
     END IF
  END DO




  nrow_postibd = -1                      ! There is a header line in postibd from Merlin
  n_location = 1
  DO 
     READ (13,*,IOSTAT=InputStatus) fam, countA, countA, loc
     IF(InputStatus .EQ. 0) THEN
        nrow_postibd=nrow_postibd+1
     ELSE IF (InputStatus .LT. 0) THEN   ! end of file
        EXIT
     ELSE IF (InputStatus .GT. 0) THEN   ! Input Error
        WRITE(*,*) 'Input error in postibd !'
        STOP
     END IF
     IF ( nrow_postibd .GE. 2 ) THEN
        IF ( fam .NE. oldfam ) THEN
           n_location = 0
        END IF
        IF ( loc .NE. oldloc ) THEN
           n_location = n_location+1
        END IF
     END IF
     oldfam = fam
     oldloc = loc
  END DO


  WRITE(*,'(/,/,1X,A)') ' Please check the following summary information...'
  WRITE(*,*) ' There are', nrow_pedfile, 'individuals.'
!  WRITE(*,*) ' and', n_cov, 'covariate(s) in pedfile.'
  WRITE(*,*) ' The number of rows in your postibd file is', nrow_postibd, '.'

  WRITE(38,'(/,/,1X,A)') ' Please check the following summary information...'
  WRITE(38,*) ' There are', nrow_pedfile, 'individuals.'
!  WRITE(38,*) ' and', n_cov, 'covariate(s) in pedfile.'
  WRITE(38,*) ' The number of rows in your postibd file is', nrow_postibd, '.'


! Allocate memory
!  ALLOCATE(dat(n_cov+1,2))
  ALLOCATE(ped(nrow_pedfile,6))                ! CHARACTER 
  IF (ifcov .EQ. 'Y') THEN
     ALLOCATE(ped1(nrow_pedfile,7:(6+n_cov)))  ! REAL
     ALLOCATE(sample(ncov))
     ALLOCATE(mu(ncov))
  END IF
  ALLOCATE(location(n_location))
  ALLOCATE(nlocation(n_location))
  ALLOCATE(ibdsum1(3,INT(nrow_postibd/n_location)))
  ALLOCATE(ibdsum2(n_location,INT(nrow_postibd/n_location)))


!  REWIND(UNIT=11)
  REWIND(UNIT=12)
  REWIND(UNIT=13)
!  REWIND(UNIT=14)

!  ALLOCATE(se_cov(ncov))
  
!  DO i=1, n_cov+1
!     READ(11,*) dat(i,:)
!     IF (ifcov .EQ. 'Y') THEN     
!        DO j=1, ncov
!           IF ( dat(i,2) .EQ. cov(j) ) THEN
!              se_cov(j)=i+5
!           ELSE IF ( cov(j) .EQ. 'SEX' ) THEN
!              se_cov(j)=5
!           END IF
!        END DO
!     END IF
!  END DO

!  WRITE(*,'(/,1X,A)') ' Reading datfile succeeded !'

  DO i=1, nrow_pedfile
     IF (ifcov .EQ. 'Y') THEN
        READ(12,*) ped(i,:), ped1(i,:)
     ELSE
        READ(12,*) ped(i,:)
     END IF
  END DO

  WRITE(*,*) ' Reading pedfile succeeded !'
  WRITE(38,*) ' Reading pedfile succeeded !'


  IF (ifcov .EQ. 'Y') THEN
     WRITE(*,'(/,1X,A)') ' Selected Covariates :'
     WRITE(*,'(1X,A)') '     Covariate             Sample Size       Mean   '
     WRITE(*,'(1X,A)') ' =========================================================='
     sample=0
     mu=0.0_dp
     DO i=1, ncov
        IF (se_cov(i) .GT. 6) THEN
           tp=0.0_dp
           DO j=1, nrow_pedfile
              IF ( ABS(ped1(j,se_cov(i))-missing) .GT. eps1 ) THEN
                 sample(i)=sample(i)+1
                 tp=tp+ped1(j,se_cov(i))
              END IF
           END DO
           mu(i)=tp/sample(i)
           WRITE(*,'(6X,A,I6,6X,F10.4)') cov(i), sample(i), mu(i) 
        END IF
     END DO
  END IF


  k=1    ! count of locations
  j=1    ! count of pairs
  l=0    ! count of pairs accumulated in previous families


  DO i=0, nrow_postibd
     IF (i .EQ. 0) THEN
        READ(13,*) countA
     ELSE IF (i .GT. 0) THEN
        READ(13,*) ibd(1:3), loca, prob(1:3)
        IF (i .GT. 1) THEN
           IF ( ibd(1) .EQ. preibd(1) ) THEN                     ! the same family
              IF ( ABS(loca-oldloca) .LT. eps1 ) THEN            ! the same location
                 j=j+1                                           ! different pairs
              ELSE IF ( ABS(loca-oldloca) .GE. eps1 ) THEN       ! the next location
                 k=k+1
                 j=l+1
              END IF
           ELSE IF ( ibd(1) .NE. preibd(1) ) THEN                ! the next family
              l=j
              k=1
              j=j+1
           END IF
        END IF
        ibdsum2(k,j) = 2.0_dp*prob(3)+prob(2)
        IF (k .EQ. 1) THEN
           ibdsum1(1,j) = ibd(1)
           ibdsum1(2,j) = ibd(2)
           ibdsum1(3,j) = ibd(3)
        END IF
        IF (j .EQ. 1) THEN
           location(k) = loca
        END IF
        preibd = ibd
        oldloca = loca
     END IF
  END DO

  WRITE(*,'(1X,A,/)') ' Reading ibdfile succeeded !'
  WRITE(38,'(1X,A,/)') ' Reading ibdfile succeeded !'

!  CLOSE(UNIT=11)
  CLOSE(UNIT=12)
  CLOSE(UNIT=13)


  cou=1
  DO i=2, nrow_pedfile
     IF (ped(i,1) .NE. ped(i-1,1)) THEN
        cou=cou+1
     END IF
  END DO

  ALLOCATE(indi(cou))

  cou=1
  indi=1
  
  DO i=2, nrow_pedfile
     IF (ped(i,1) .EQ. ped(i-1,1)) THEN
        indi(cou)=indi(cou)+1
     ELSE IF (ped(i,1) .NE. ped(i-1,1)) THEN
        cou=cou+1
     END IF
  END DO

  IF (SUM(indi) .NE. nrow_pedfile) THEN
     WRITE(*,*) 'There is inconsistency in the counting of all individuals.'
     WRITE(*,*) 'Please examine the pedfile !'
     STOP
  END IF


  l=0   ! the number of individuals accumulated in the past families
  j=1   ! one individual in a pair
  k=1   ! the other individual in the pair
  tmp=1
  typerel=0
  cou=0

  ALLOCATE(rel(INT(nrow_postibd/n_location)))
  ALLOCATE(family(INT(nrow_postibd/n_location)))
  ALLOCATE(IBDS(n_location,INT(nrow_postibd/n_location)))
  
  IF (ifcov .EQ. 'Y') THEN
     IF ( (FUN .EQ. 'D') .OR. (FUN .EQ. 'C') ) THEN
        ALLOCATE(arpcov(ncov,1,INT(nrow_postibd/n_location)))
     ELSE IF ( (FUN .EQ. 'B') ) THEN
        ALLOCATE(arpcov(ncov,2,INT(nrow_postibd/n_location)))
     END IF
  END IF

  rel=0
  IBDS=0.0_dp

  DO i=1, INT(nrow_postibd/n_location)

     DO ss=1, nrow_pedfile
        IF ( ped(ss,1) .EQ. ibdsum1(1,i) ) THEN
           l=ss-1
           EXIT
        END IF
     END DO
    
     j=l+1
     IF( ibdsum1(2,i) .NE. ibdsum1(3,i) ) THEN
        DO WHILE (j .GT. l)
           IF ( ped(j,1) .NE. ibdsum1(1,i) ) THEN
              EXIT
           ELSE IF ( ped(j,1) .EQ. ibdsum1(1,i) ) THEN
              IF ( ((ped(j,2) .EQ. ibdsum1(2,i)) .OR. (ped(j,2) .EQ. ibdsum1(3,i))) .AND. (ped(j,6) .EQ. '2') ) THEN
                 k=l+1
                 DO WHILE (k .GT. l)
                    IF ( ped(k,1) .NE. ibdsum1(1,i) ) THEN
                       GOTO 999
                    ELSE IF ( ped(k,1) .EQ. ibdsum1(1,i) ) THEN
                       IF (k .GT. j) THEN
                          IF ( ((ped(k,2) .EQ. ibdsum1(2,i)) .OR. (ped(k,2) .EQ. ibdsum1(3,i))) .AND. (ped(k,6) .EQ. '2') ) THEN
                             parent(1,1)=ped(j,3)
                             parent(2,1)=ped(j,4)
                             parent(1,2)=ped(k,3)
                             parent(2,2)=ped(k,4)
                             IF ( (parent(1,1) .EQ. parent(1,2)) .AND. (parent(2,1) .EQ. parent(2,2)) .AND.  &
                                & (parent(1,1) .NE. '0') .AND. (parent(2,1) .NE. '0') ) THEN
                                couinf=0
                                DO mm=1, n_location
                                   IF ( ABS(ibdsum2(mm,i)-1.0_dp) .LE. eps3 ) THEN
                                      couinf=couinf+1
                                   END IF
                                END DO
                                IF (couinf .EQ. n_location) THEN
                                   GOTO 612
                                END IF
                                typerel(1)=typerel(1)+1   ! Full siblings
                                cou=cou+1
                                rel(cou)=1
                                family(cou)=ibdsum1(1,i)
                                IBDS(:,cou)=ibdsum2(:,i)
                                IF (ifcov .EQ. 'Y') THEN
                                   DO cc=1, ncov
                                      IF ( se_cov(cc) .GT. 6 ) THEN
                                         IF ( (ABS(ped1(j,se_cov(cc))-missing) .LT. eps1) .OR.  &
                                              &  (ABS(ped1(k,se_cov(cc))-missing) .LT. eps1) ) THEN
                                            arpcov(cc,:,cou)=missing  ! missing
                                         ELSE 
                                            IF ( FUN .EQ. 'D' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                            ELSE IF ( FUN .EQ. 'C' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                            ELSE IF ( FUN .EQ. 'B' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                               arpcov(cc,2,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                            END IF
                                         END IF
                                      ELSE IF( se_cov(cc) .EQ. 5 ) THEN
                                         IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                            arpcov(cc,:,cou)= -1.0_dp ! Male,Male
                                         ELSE IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                            arpcov(cc,:,cou)= 0.0_dp  ! Male,Female
                                         ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                            arpcov(cc,:,cou)= 0.0_dp  ! Female,Male
                                         ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                            arpcov(cc,:,cou)= 1.0_dp  ! Female,Female
                                         END IF
                                      END IF
                                   END DO
                                END IF
                                  !WRITE(*,*) ibdsum1(1,i), ibdsum1(2,i), ibdsum1(3,i), rel(cou)
                                  !WRITE(*,*) arpcov(:,1,cou)
                                  !WRITE(*,*) arpcov(:,2,cou)
                                  !STOP
                             ELSE IF ( ((parent(1,1) .EQ. parent(1,2)) .AND. (parent(1,1) .NE. '0')) .OR.  &
                                &      ((parent(2,1) .EQ. parent(2,2)) .AND. (parent(2,1) .NE. '0')) ) THEN
                                couinf=0
                                DO mm=1, n_location
                                   IF ( ABS(ibdsum2(mm,i)-0.5_dp) .LE. eps3 ) THEN
                                      couinf=couinf+1
                                   END IF
                                END DO
                                IF (couinf .EQ. n_location) THEN
                                   GOTO 612
                                END IF
                                typerel(2)=typerel(2)+1   ! Half siblings
                                cou=cou+1
                                rel(cou)=2
                                family(cou)=ibdsum1(1,i)
                                IBDS(:,cou)=ibdsum2(:,i)
                                IF (ifcov .EQ. 'Y') THEN
                                   DO cc=1, ncov
                                      IF ( se_cov(cc) .GT. 6 ) THEN
                                         IF ( (ABS(ped1(j,se_cov(cc))-missing) .LT. eps1) .OR.  &
                                              &  (ABS(ped1(k,se_cov(cc))-missing) .LT. eps1) ) THEN
                                            arpcov(cc,:,cou)=missing  ! missing
                                         ELSE 
                                            IF ( FUN .EQ. 'D' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                            ELSE IF ( FUN .EQ. 'C' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                            ELSE IF ( FUN .EQ. 'B' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                               arpcov(cc,2,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                            END IF
                                         END IF
                                      ELSE IF( se_cov(cc) .EQ. 5 ) THEN
                                         IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                            arpcov(cc,:,cou)= -1.0_dp  ! Male,Male
                                         ELSE IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                            arpcov(cc,:,cou)= 0.0_dp  ! Male,Female
                                         ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                            arpcov(cc,:,cou)= 0.0_dp  ! Female,Male
                                         ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                            arpcov(cc,:,cou)= 1.0_dp  ! Female,Female
                                         END IF
                                      END IF
                                   END DO
                                END IF
                                !  WRITE(*,*) ibdsum1(1,i), ibdsum1(2,i), ibdsum1(3,i), rel(cou)
                             ELSE
                                gparent = '0'
                                j1=l+1
                                DO WHILE (j1 .GT. l)      ! Search Father and Mother of the first person's Father
                                   IF ( ped(j1,1) .NE. ibdsum1(1,i) ) THEN
                                      EXIT
                                   ELSE IF ( ped(j1,1) .EQ. ibdsum1(1,i) ) THEN
                                      IF ( parent(1,1) .NE. '0' ) THEN
                                         IF ( ped(j1,2) .EQ. parent(1,1) ) THEN
                                            gparent(1,1)=ped(j1,3)
                                            gparent(2,1)=ped(j1,4)
                                         END IF
                                      END IF
                                   END IF
                                   j1=j1+1
                                END DO
                                j2=l+1
                                DO WHILE (j2 .GT. l)      ! Search Father and Mother of the first person's Mother
                                   IF ( ped(j2,1) .NE. ibdsum1(1,i) ) THEN
                                      EXIT
                                   ELSE IF ( ped(j2,1) .EQ. ibdsum1(1,i) ) THEN
                                      IF ( parent(2,1) .NE. '0' ) THEN
                                         IF ( ped(j2,2) .EQ. parent(2,1) ) THEN
                                            gparent(3,1)=ped(j2,3)
                                            gparent(4,1)=ped(j2,4)
                                         END IF
                                      END IF
                                   END IF
                                   j2=j2+1
                                END DO
                                k1=l+1
                                DO WHILE (k1 .GT. l)      ! Search Father and Mother of the second person's Father
                                   IF ( ped(k1,1) .NE. ibdsum1(1,i) ) THEN
                                      EXIT
                                   ELSE IF ( ped(k1,1) .EQ. ibdsum1(1,i) ) THEN
                                      IF ( parent(1,2) .NE. '0' ) THEN
                                         IF ( ped(k1,2) .EQ. parent(1,2) ) THEN
                                            gparent(1,2)=ped(k1,3)
                                            gparent(2,2)=ped(k1,4)
                                         END IF
                                      END IF
                                   END IF
                                   k1=k1+1
                                END DO
                                k2=l+1
                                DO WHILE (k2 .GT. l)      ! Search Father and Mother of the second person's Mother
                                   IF ( ped(k2,1) .NE. ibdsum1(1,i) ) THEN
                                      EXIT
                                   ELSE IF ( ped(k2,1) .EQ. ibdsum1(1,i) ) THEN
                                      IF ( parent(2,2) .NE. '0' ) THEN
                                         IF ( ped(k2,2) .EQ. parent(2,2) ) THEN
                                            gparent(3,2)=ped(k2,3)
                                            gparent(4,2)=ped(k2,4)
                                         END IF
                                      END IF
                                   END IF
                                   k2=k2+1
                                END DO
                                IF ( (((gparent(1,1) .EQ. gparent(1,2)) .AND. (gparent(1,1) .NE. '0')) .AND.  &
                                   &  ((gparent(2,1) .EQ. gparent(2,2)) .AND. (gparent(2,1) .NE. '0'))) .OR.  &
                                   & (((gparent(3,1) .EQ. gparent(3,2)) .AND. (gparent(3,1) .NE. '0')) .AND.  &
                                   &  ((gparent(4,1) .EQ. gparent(4,2)) .AND. (gparent(4,1) .NE. '0'))) .OR.  &
                                   & (((gparent(1,1) .EQ. gparent(3,2)) .AND. (gparent(1,1) .NE. '0')) .AND.  &
                                   &  ((gparent(2,1) .EQ. gparent(4,2)) .AND. (gparent(2,1) .NE. '0'))) .OR.  &
                                   & (((gparent(3,1) .EQ. gparent(1,2)) .AND. (gparent(3,1) .NE. '0')) .AND.  &
                                   &  ((gparent(4,1) .EQ. gparent(2,2)) .AND. (gparent(4,1) .NE. '0')))  ) THEN
                                   couinf=0
                                   DO mm=1, n_location
                                      IF ( ABS(ibdsum2(mm,i)-0.25_dp) .LE. eps3 ) THEN
                                         couinf=couinf+1
                                      END IF
                                   END DO
                                   IF (couinf .EQ. n_location) THEN
                                      GOTO 612
                                   END IF
                                   typerel(3)=typerel(3)+1   ! First cousins
                                   cou=cou+1
                                   rel(cou)=3
                                   family(cou)=ibdsum1(1,i)
                                   IBDS(:,cou)=ibdsum2(:,i)
                                   IF (ifcov .EQ. 'Y') THEN
                                      DO cc=1, ncov
                                         IF ( se_cov(cc) .GT. 6 ) THEN
                                            IF ( (ABS(ped1(j,se_cov(cc))-missing) .LT. eps1) .OR.  &
                                                 &  (ABS(ped1(k,se_cov(cc))-missing) .LT. eps1) ) THEN
                                               arpcov(cc,:,cou)=missing  ! missing
                                            ELSE 
                                               IF ( FUN .EQ. 'D' ) THEN
                                                  arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                            ELSE IF ( FUN .EQ. 'C' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                            ELSE IF ( FUN .EQ. 'B' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                               arpcov(cc,2,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                               END IF
                                            END IF
                                         ELSE IF( se_cov(cc) .EQ. 5 ) THEN
                                            IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                               arpcov(cc,:,cou)= -1.0_dp  ! Male,Male
                                            ELSE IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                               arpcov(cc,:,cou)= 0.0_dp  ! Male,Female
                                            ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                               arpcov(cc,:,cou)= 0.0_dp  ! Female,Male
                                            ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                               arpcov(cc,:,cou)= 1.0_dp  ! Female,Female
                                            END IF
                                         END IF
                                      END DO
                                   END IF
                                   !  WRITE(*,*) ibdsum1(1,i), ibdsum1(2,i), ibdsum1(3,i), rel(cou)
                                   !  WRITE(*,*) gparent(:,1)
                                   !  WRITE(*,*) gparent(:,2)
                                END IF
                                IF ( (gparent(1,1) .EQ. ped(k,2)) .OR. (gparent(2,1) .EQ. ped(k,2))  .OR.  &
                                   & (gparent(3,1) .EQ. ped(k,2)) .OR. (gparent(4,1) .EQ. ped(k,2))  .OR.  &
                                   & (gparent(1,2) .EQ. ped(j,2)) .OR. (gparent(2,2) .EQ. ped(j,2))  .OR.  &
                                   & (gparent(3,2) .EQ. ped(j,2)) .OR. (gparent(4,2) .EQ. ped(j,2)) ) THEN
                                   couinf=0
                                   DO mm=1, n_location
                                      IF ( ABS(ibdsum2(mm,i)-0.5_dp) .LE. eps3 ) THEN
                                         couinf=couinf+1
                                      END IF
                                   END DO
                                   IF (couinf .EQ. n_location) THEN
                                      GOTO 612
                                   END IF
                                   typerel(4)=typerel(4)+1   ! Grandparent-grandchild pair
                                   cou=cou+1
                                   rel(cou)=4
                                   family(cou)=ibdsum1(1,i)
                                   IBDS(:,cou)=ibdsum2(:,i)
                                   IF (ifcov .EQ. 'Y') THEN
                                      DO cc=1, ncov
                                         IF ( se_cov(cc) .GT. 6 ) THEN
                                            IF ( (ABS(ped1(j,se_cov(cc))-missing) .LT. eps1) .OR.  &
                                                 &  (ABS(ped1(k,se_cov(cc))-missing) .LT. eps1) ) THEN
                                               arpcov(cc,:,cou)=missing  ! missing
                                            ELSE 
                                               IF ( FUN .EQ. 'D' ) THEN
                                                  arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                            ELSE IF ( FUN .EQ. 'C' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                            ELSE IF ( FUN .EQ. 'B' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                               arpcov(cc,2,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                               END IF
                                            END IF
                                         ELSE IF( se_cov(cc) .EQ. 5 ) THEN
                                            IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                               arpcov(cc,:,cou)= -1.0_dp  ! Male,Male
                                            ELSE IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                               arpcov(cc,:,cou)= 0.0_dp  ! Male,Female
                                            ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                               arpcov(cc,:,cou)= 0.0_dp  ! Female,Male
                                            ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                               arpcov(cc,:,cou)= 1.0_dp  ! Female,Female
                                            END IF
                                         END IF
                                      END DO
                                   END IF
                                   !  WRITE(*,*) ibdsum1(1,i), ibdsum1(2,i), ibdsum1(3,i), rel(cou)
                                   !  WRITE(*,*) gparent(:,1)
                                   !  WRITE(*,*) gparent(:,2)
                                END IF
                                IF ( ((((gparent(1,1) .EQ. parent(1,2)) .AND. (gparent(1,1) .NE. '0')) .AND.  &
                                   &  ((gparent(2,1) .EQ. parent(2,2)) .AND. (gparent(2,1) .NE. '0'))) .OR.  &
                                   & (((gparent(3,1) .EQ. parent(1,2)) .AND. (gparent(3,1) .NE. '0')) .AND.  &
                                   &  ((gparent(4,1) .EQ. parent(2,2)) .AND. (gparent(4,1) .NE. '0'))) .OR.  &
                                   & (((gparent(1,2) .EQ. parent(1,1)) .AND. (gparent(1,2) .NE. '0')) .AND.  &
                                   &  ((gparent(2,2) .EQ. parent(2,1)) .AND. (gparent(2,2) .NE. '0'))) .OR.  &
                                   & (((gparent(3,2) .EQ. parent(1,1)) .AND. (gparent(3,2) .NE. '0')) .AND.  &
                                   &  ((gparent(4,2) .EQ. parent(2,1)) .AND. (gparent(4,2) .NE. '0')))) .AND. &  
                                   &  ((ped(j,2) .NE. parent(1,2)) .AND. (ped(j,2) .NE. parent(2,2)) .AND.  &
                                   &   (ped(k,2) .NE. parent(1,1)) .AND. (ped(k,2) .NE. parent(2,1)) )  ) THEN
                                   couinf=0
                                   DO mm=1, n_location
                                      IF ( ABS(ibdsum2(mm,i)-0.5_dp) .LE. eps3 ) THEN
                                         couinf=couinf+1
                                      END IF
                                   END DO
                                   IF (couinf .EQ. n_location) THEN
                                      GOTO 612
                                   END IF
                                   typerel(5)=typerel(5)+1   ! Avucular pairs
                                   cou=cou+1
                                   rel(cou)=5
                                   family(cou)=ibdsum1(1,i)
                                   IBDS(:,cou)=ibdsum2(:,i)
                                   IF (ifcov .EQ. 'Y') THEN
                                      DO cc=1, ncov
                                         IF ( se_cov(cc) .GT. 6 ) THEN
                                            IF ( (ABS(ped1(j,se_cov(cc))-missing) .LT. eps1) .OR.  &
                                                 &  (ABS(ped1(k,se_cov(cc))-missing) .LT. eps1) ) THEN
                                               arpcov(cc,:,cou)=missing  ! missing
                                            ELSE 
                                               IF ( FUN .EQ. 'D' ) THEN
                                                  arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                            ELSE IF ( FUN .EQ. 'C' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                            ELSE IF ( FUN .EQ. 'B' ) THEN
                                               arpcov(cc,1,cou)=(ped1(j,se_cov(cc))-ped1(k,se_cov(cc)))**2
                                               arpcov(cc,2,cou)=(ped1(j,se_cov(cc))-mu(cc))*(ped1(k,se_cov(cc))-mu(cc))
                                               END IF
                                            END IF
                                         ELSE IF( se_cov(cc) .EQ. 5 ) THEN
                                            IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                               arpcov(cc,:,cou)= -1.0_dp  ! Male,Male
                                            ELSE IF ( (ped(j,se_cov(cc)) .EQ. '1') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                               arpcov(cc,:,cou)= 0.0_dp  ! Male,Female
                                            ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '1') ) THEN
                                               arpcov(cc,:,cou)= 0.0_dp  ! Female,Male
                                            ELSE IF ( (ped(j,se_cov(cc)) .EQ. '2') .AND. (ped(k,se_cov(cc)) .EQ. '2') ) THEN
                                               arpcov(cc,:,cou)= 1.0_dp  ! Female,Female
                                            END IF
                                         END IF
                                      END DO
                                   END IF
                                   !  WRITE(*,*) ibdsum1(1,i), ibdsum1(2,i), ibdsum1(3,i), rel(cou)
                                   !  WRITE(*,*) gparent(:,1)
                                   !  WRITE(*,*) gparent(:,2)
                                END IF                                
                             END IF
                          END IF
                       END IF
                    END IF
612                 k=k+1
                 END DO
              END IF
           END IF
           j=j+1
        END DO
999  END IF
  END DO


             
  cou=0
  DO i=1, 5
     IF ( typerel(i) .GE. 15 ) THEN
        cou=cou+1
     END IF
  END DO

  ALLOCATE(typereln(cou))
  ALLOCATE(typeno(cou))
  ALLOCATE(typename(cou))
  ALLOCATE(temp(cou))


!  NN=2+cou*2           ! Number of parameters that need to be estimated in unconstrained-model approach

  typereln=0
  l=0
  DO i=1, 5
     IF ( typerel(i) .GE. 15 ) THEN
        l=l+1
        typereln(l)=typerel(i)
        typeno(l)=i
        SELECT CASE (i)
           CASE (1)
              typename(l)='FS'
           CASE (2)
              typename(l)='HS'
           CASE (3)
              typename(l)='FC'
           CASE (4)
              typename(l)='GP'
           CASE (5)
              typename(l)='AP'
        END SELECT
     END IF
  END DO  



  ALLOCATE(reln(SUM(typereln)))
  ALLOCATE(familytmp(SUM(typereln)))
  ALLOCATE(familyn(SUM(typereln)))
  ALLOCATE(IBDSn(n_location,SUM(typereln)))

  IF (ifcov .EQ. 'Y') THEN
     IF ( (FUN .EQ. 'D') .OR. (FUN .EQ. 'C') ) THEN
        ALLOCATE(arpcovn(ncov,1,SUM(typereln)))
     ELSE IF ( (FUN .EQ. 'B') ) THEN
        ALLOCATE(arpcovn(ncov,2,SUM(typereln)))
     END IF
     ALLOCATE(sample_arpcovn(cou,ncov))
  END IF

  j=0
  familyn(1)=1
  sample_arpcovn=0
  DO i=1, INT(nrow_postibd/n_location)
     DO k=1, cou
        IF ( rel(i) .EQ. typeno(k) ) THEN
           j=j+1
           reln(j)=rel(i)
           familytmp(j)=family(i)
           IF ( j .GT. 1 ) THEN
              IF ( familytmp(j) .NE. familytmp(j-1) ) THEN
                 familyn(j)=familyn(j-1)+1
              ELSE IF ( familytmp(j) .EQ. familytmp(j-1) ) THEN
                 familyn(j)=familyn(j-1)
              END IF
           END IF
           IBDSn(:,j)=IBDS(:,i)
           IF (ifcov .EQ. 'Y') THEN
              arpcovn(:,:,j)=arpcov(:,:,i)
              DO cc=1, ncov
                 IF (se_cov(cc) .GT. 6) THEN
                    IF ( ABS(arpcovn(cc,1,j)-missing) .GT. eps1 ) THEN
                       sample_arpcovn(k,cc)=sample_arpcovn(k,cc)+1
                    END IF
                 END IF
              END DO
           END IF
        END IF
     END DO
  END DO


  IF (ifcov .EQ. 'Y') THEN
     WRITE(*,'(/,1X,A)') ' Selected Covariates :'
     SELECT CASE (cou)
     CASE (5)
        WRITE(*,*) ' Covariate               ALL ARPs    ', typename
        WRITE(*,'(1X,A)') ' ========================================================================'
        DO i=1, ncov
           IF (se_cov(i) .GT. 6) THEN
              WRITE(*,'(2X,A,6I7)') cov(i), SUM(sample_arpcovn(:,i)), sample_arpcovn(:,i)
           END IF
        END DO
     CASE (4)
        WRITE(*,*) ' Covariate               ALL ARPs    ', typename
        WRITE(*,'(1X,A)') ' ================================================================'
        DO i=1, ncov
           IF (se_cov(i) .GT. 6) THEN
              WRITE(*,'(2X,A,5I7)') cov(i), SUM(sample_arpcovn(:,i)), sample_arpcovn(:,i)
           END IF
        END DO
     CASE (3)
        WRITE(*,*) ' Covariate               ALL ARPs    ', typename
        WRITE(*,'(1X,A)') ' ========================================================'
        DO i=1, ncov
           IF (se_cov(i) .GT. 6) THEN
              WRITE(*,'(2X,A,4I7)') cov(i), SUM(sample_arpcovn(:,i)), sample_arpcovn(:,i)
           END IF
        END DO
     CASE (2)
        WRITE(*,*) ' Covariate               ALL ARPs    ', typename
        WRITE(*,'(1X,A)') ' ================================================'
        DO i=1, ncov
           IF (se_cov(i) .GT. 6) THEN
              WRITE(*,'(2X,A,3I7)') cov(i), SUM(sample_arpcovn(:,i)), sample_arpcovn(:,i)
           END IF
        END DO
     CASE (1)
        WRITE(*,*) ' Covariate               ALL ARPs    ', typename
        WRITE(*,'(1X,A)') ' ========================================'
        DO i=1, ncov
           IF (se_cov(i) .GT. 6) THEN
              WRITE(*,'(2X,A,2I7)') cov(i), SUM(sample_arpcovn(:,i)), sample_arpcovn(:,i)
           END IF
        END DO
     END SELECT
  END IF


  DEALLOCATE(ibdsum1)
  DEALLOCATE(ibdsum2)
  DEALLOCATE(indi)
  DEALLOCATE(rel)
  DEALLOCATE(family)
  DEALLOCATE(IBDS)
!  DEALLOCATE(dat)
  DEALLOCATE(ped)

  IF (ifcov .EQ. 'Y') THEN
     DEALLOCATE(ped1)
     DEALLOCATE(arpcov)
  END IF

  ALLOCATE(subfamilyn1(typerel(1)))
  ALLOCATE(subfamilyn2(typerel(2)))
  ALLOCATE(subfamilyn3(typerel(3)))
  ALLOCATE(subfamilyn4(typerel(4)))
  ALLOCATE(subfamilyn5(typerel(5)))

  subfamilyn1=0
  subfamilyn2=0
  subfamilyn3=0
  subfamilyn4=0
  subfamilyn5=0


  DO j=1, 5
     l=0
     ALLOCATE ( subfam(typerel(j)) ) 
     ALLOCATE ( subfamtmp(typerel(j)) )

     DO i=1, SUM(typerel)
        IF ( reln(i) .EQ. j ) THEN
           l=l+1
           subfam(l)=familyn(i)
        END IF
     END DO

     IF ( typerel(j) .EQ. 1) THEN        
        subfamtmp(1)=1
     END IF

     IF ( typerel(j) .GT. 1) THEN 
        subfamtmp(1)=1       
        DO i=2, typerel(j)
           IF ( subfam(i) .EQ. subfam(i-1) ) THEN
              subfamtmp(i)=subfamtmp(i-1)
           ELSE IF ( subfam(i) .NE. subfam(i-1) ) THEN
              subfamtmp(i)=subfamtmp(i-1)+1
           END IF
        END DO
     END IF

     SELECT CASE (j)
        CASE (1)
           subfamilyn1=subfamtmp
        CASE (2)
           subfamilyn2=subfamtmp
        CASE (3)
           subfamilyn3=subfamtmp
        CASE (4)
           subfamilyn4=subfamtmp
        CASE (5)
           subfamilyn5=subfamtmp
     END SELECT

     DEALLOCATE ( subfam )
     DEALLOCATE ( subfamtmp )

  END DO


  WRITE(*,'(/,/,A,I6,2X,A)') ' There are totally', SUM(typerel), 'affected relative pairs, including :'
  WRITE(*,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(1), 'full-sib pairs (FS) from', subfamilyn1(typerel(1)), 'families,'  
  WRITE(*,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(2), 'half-sib pairs (HS) from', subfamilyn2(typerel(2)), 'families,' 
  WRITE(*,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(3), 'first-cousin pairs (FC) from', subfamilyn3(typerel(3)), 'families,'  
  WRITE(*,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(4), 'grandparent-grandchild pairs (GP) from', subfamilyn4(typerel(4)), 'families, and' 
  WRITE(*,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(5), 'avuncular pairs (AP) from', subfamilyn5(typerel(5)), 'families.' 
  WRITE(*,*) ' The following analysis will discard the kinds of ARPs with less than 15 pairs.'
  WRITE(*,*) ' Thus ', typename, 'will be analyzed,' 
  WRITE(*,*) ' and', SUM(typereln), 'ARPs from', familyn(SUM(typereln)), 'families will be incorporated into the analysis.'


  WRITE(38,'(/,/,A,I6,2X,A)') ' There are totally', SUM(typerel), 'affected relative pairs, including :'
  WRITE(38,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(1), 'full-sib pairs (FS) from', subfamilyn1(typerel(1)), 'families,'  
  WRITE(38,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(2), 'half-sib pairs (HS) from', subfamilyn2(typerel(2)), 'families,' 
  WRITE(38,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(3), 'first-cousin pairs (FC) from', subfamilyn3(typerel(3)), 'families,'  
  WRITE(38,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(4), 'grandparent-grandchild pairs (GP) from', subfamilyn4(typerel(4)), 'families, and' 
  WRITE(38,'(1X,I4,2X,A,1X,I4,2X,A)') typerel(5), 'avuncular pairs (AP) from', subfamilyn5(typerel(5)), 'families.' 
  WRITE(38,*) ' The following analysis will discard the kinds of ARPs with less than 15 pairs.'
  WRITE(38,*) ' Thus ', typename, 'will be analyzed,' 
  WRITE(38,*) ' and', SUM(typereln), 'ARPs from', familyn(SUM(typereln)), 'families will be incorporated into the analysis.'



  ! Get mean-ibd plot

  OPEN(UNIT=1,FILE='mean.ibd')

  WRITE(*,'(/,1X,A,/)') ' Average IBD scores were stored in file [mean.ibd]'
  WRITE(1,*)  '   LOCATION ', '   ALL      ', typename
  WRITE(1,'(1X,A)') ' ==================================================================='

  WRITE(38,'(/,1X,A,/)') ' Average IBD scores were stored in file [mean.ibd]'

  DO i=1, n_location
     temp=0.0_dp
     DO j=1, SUM(typereln)
        DO k=1, cou
           IF ( reln(j) .EQ. typeno(k) ) THEN
              temp(k)=temp(k)+IBDSn(i,j)
           END IF
        END DO
     END DO
     SELECT CASE (cou)
        CASE (1)
           WRITE(1,1) location(i), SUM(IBDSn(i,1:SUM(typereln)))/REAL(SUM(typereln)), temp/REAL(SUM(typereln))
        CASE (2)
           WRITE(1,2) location(i), SUM(IBDSn(i,1:SUM(typereln)))/REAL(SUM(typereln)),  &
                &     temp(1)/REAL(typereln(1)), temp(2)/REAL(typereln(2))
        CASE (3)
           WRITE(1,3) location(i), SUM(IBDSn(i,1:SUM(typereln)))/REAL(SUM(typereln)),  &
                &     temp(1)/REAL(typereln(1)), temp(2)/REAL(typereln(2)), temp(3)/REAL(typereln(3))
        CASE (4)
           WRITE(1,4) location(i), SUM(IBDSn(i,1:SUM(typereln)))/REAL(SUM(typereln)),  &
                &     temp(1)/REAL(typereln(1)), temp(2)/REAL(typereln(2)), temp(3)/REAL(typereln(3)), temp(4)/REAL(typereln(4))
        CASE (5)
           WRITE(1,5) location(i), SUM(IBDSn(i,1:SUM(typereln)))/REAL(SUM(typereln)),  &
                &     temp(1)/REAL(typereln(1)), temp(2)/REAL(typereln(2)), temp(3)/REAL(typereln(3)), temp(4)/REAL(typereln(4)),  &
                &     temp(5)/REAL(typereln(5))
     END SELECT
  END DO




  nlocation=location/100.0_dp  
  ini =0



  DO

     IF ( ini .GE. initest ) THEN
        EXIT
     END IF


     IF ( (MODEL .EQ. 'B') .OR. (MODEL .EQ. '1') ) THEN


        WRITE(*,'(/,A,/)') ' ====== Fit a one-locus model, randomly select the initial values ====== '
        WRITE(*,'(A,I3,2X,A,/)') ' ==================  INITIAL VALUES TEST ', ini+1, ' ================== ' 

        WRITE(38,'(/,A,/)') ' ====== Fit a one-locus model, randomly select the initial values ====== '
        WRITE(38,'(A,I3,2X,A,/)') ' ==================  INITIAL VALUES TEST ', ini+1, ' ================== '

       
        CALL RANDOM_SEED
        CALL RANDOM_NUMBER(uu)    
        xini(1) = (nlocation(n_location)/1.0_dp)*uu
        x1tmp = xini(1)*100.0_dp
        
!        CALL RANDOM_SEED
!        CALL RANDOM_NUMBER(uu)  
        xini(3) = 0.1_dp


        WRITE(*,'(A,2X,F7.3,2X,A)') ' Randomly select the initial value for gene location to be', x1tmp, 'cM.'
        WRITE(*,'(A,2X,F7.3)') ' The initial value of genetic effects for all kinds of ARPs is set at', xini(3)

        WRITE(38,'(A,2X,F7.3,2X,A)') ' Randomly select the initial value for gene location to be', x1tmp, 'cM.'
        WRITE(38,'(A,2X,F7.3)') ' The initial value of genetic effects for all kinds of ARPs is set at', xini(3)

        IF ( (METHOD .EQ. 'S') .OR. (METHOD .EQ. 'B') ) THEN

           ! 1. Subset - FS
           IF ( FS .EQ. 1) THEN
              IF (typerel(1) .GE. 15) THEN
                 NN = 2
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn1(n_location,typerel(1)))
                 ALLOCATE(reln1(typerel(1)))
                 ALLOCATE(familyn1tmp(typerel(1)))
                 ALLOCATE(familyn1(typerel(1)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 1) THEN
                       j = j+1
                       IBDSn1(:,j) = IBDSn(:,i)
                       familyn1tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn1(1) = 1
                 DO i=2, typerel(1)
                    IF ( familyn1tmp(i) .NE. familyn1tmp(i-1) ) THEN
                       familyn1(i) = familyn1(i-1)+1
                    ELSE IF ( familyn1tmp(i) .EQ. familyn1tmp(i-1) ) THEN
                       familyn1(i) = familyn1(i-1)
                    END IF
                 END DO
                 x(1) = xini(1)
                 x(2) = xini(3)
                 arpno = typerel(1)
                 reln1 = 1
                 bound(1,1) = nlocation(1)            ! lower bound
                 bound(1,2) = nlocation(n_location)   ! upper bound
                 bound(2,1) = -1.0_dp                 ! lower bound
                 bound(2,2) = 0.5_dp                  ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ================   Full-Sib subset analysis result   =================='
                 WRITE(38,'(/,A,/)') ' ================   Full-Sib subset analysis result   =================='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
                    
61                  CALL fcnone1 (NN, x, fvec, arpno, IBDSn1, reln1, eps, IinvU, familyn1, subfamilyn1(typerel(1)), nlocation, &
                         &     n_location, varp)
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,108) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                WRITE(38,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 72
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)                          
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.' 
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau  =', MAX(0.0_dp,x(1)*100.0_dp),  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C1 (FS) =', x(2), '(', x(2)-1.96_dp*se(2), '-',  &
                               &       MIN(x(2)+1.96_dp*se(2),1.0_dp), ')'    
                          lambda1=1.0_dp/(1.0_dp-2.0_dp*x(2))
                          sel1=((2.0_dp/(1.0_dp-2.0_dp*x(2))**2)**2*varp(2,2))**0.5
                          WRITE(*,800) ' Risk ratio lambda1 (FS) =', MAX(0.0_dp,lambda1),  &
                               &  '(', MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,*)   '            tau      ', '   C1  '
                          WRITE(*,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(*,308) '   C1  ', varp(2,1), varp(2,2)

                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.' 
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau  =', MAX(0.0_dp,x(1)*100.0_dp),  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C1 (FS) =', x(2), '(', x(2)-1.96_dp*se(2), '-',  &
                               &       MIN(x(2)+1.96_dp*se(2),1.0_dp), ')'    
                          WRITE(38,800) ' Risk ratio lambda1 (FS) =', MAX(0.0_dp,lambda1),  &
                               &  '(', MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,*)   '            tau      ', '   C1  '
                          WRITE(38,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(38,308) '   C1  ', varp(2,1), varp(2,2)

                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No disease locus or too poor initial values !'
                          WRITE(38,'(A)') ' No disease locus or too poor initial values !'
                          GO TO 72
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 72
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No disease locus or too poor initial values !'
                             GO TO 72                          
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 61
                    END IF
                 END DO   ! END Fisher's scoring METHOD


72               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn1(typerel(1))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
261                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn1(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn1(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn1(:,j)
                                relb(k)=reln1(j)
                                familyb(k)=familyn1(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1) = xini(1)
                       x(2) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
161                       CALL fcnone1 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                         &     n_location, varp)
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,208) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 261
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 261
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 261                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 161
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO

                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', bootCI(1,1)*100.0_dp, '-', bootCI(1,2)*100.0_dp, ') cM.'
                    WRITE(*,800) ' Genetic effect C1 (FS) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')'                       
                    lambda1=1.0_dp/(1.0_dp-2.0_dp*avexb(2))
                    lower1=1.0_dp/(1.0_dp-2.0_dp*bootCI(2,1))
                    upper1=1.0_dp/(1.0_dp-2.0_dp*bootCI(2,2))
                    WRITE(*,800) ' Risk ratio lambda1 (FS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'



                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'
                    WRITE(38,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C1 (FS) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')'                       
                    WRITE(38,800) ' Risk ratio lambda1 (FS) =', MAX(0.0_dp,lambda1), '(', MAX(0.0_dp,lower1), '-', upper1, ')'



                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn1)
                 DEALLOCATE(reln1)
                 DEALLOCATE(familyn1tmp)
                 DEALLOCATE(familyn1)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(1) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' ================   Full-Sib subset analysis result   =================='
                 WRITE(*,'(/,A)') ' The number of full-sib pairs is under 15, skip the subset analysis for full sibs !'
                 WRITE(38,'(/,A,/)') ' ================   Full-Sib subset analysis result   =================='
                 WRITE(38,'(/,A)') ' The number of full-sib pairs is under 15, skip the subset analysis for full sibs !'
              END IF
           END IF
           
           
           ! 2. Subset - HS
           
           IF ( HS .EQ. 1 ) THEN
              IF (typerel(2) .GE. 15) THEN
                 NN = 2   
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn2(n_location,typerel(2)))
                 ALLOCATE(reln2(typerel(2)))
                 ALLOCATE(familyn2tmp(typerel(2)))
                 ALLOCATE(familyn2(typerel(2)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 2) THEN
                       j = j+1
                       IBDSn2(:,j) = IBDSn(:,i)
                       familyn2tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn2(1) = 1
                 DO i=2, typerel(2)
                    IF ( familyn2tmp(i) .NE. familyn2tmp(i-1) ) THEN
                       familyn2(i) = familyn2(i-1)+1
                    ELSE IF ( familyn2tmp(i) .EQ. familyn2tmp(i-1) ) THEN
                       familyn2(i) = familyn2(i-1)
                    END IF
                 END DO
                 x(1) = xini(1)
                 x(2) = xini(3)
                 arpno = typerel(2)
                 reln2 = 2
                 bound(1,1) = nlocation(1)            ! lower bound
                 bound(1,2) = nlocation(n_location)   ! upper bound
                 bound(2,1) = -0.5_dp                 ! lower bound
                 bound(2,2) = 0.5_dp                  ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ================   Half-Sib subset analysis result   =================='
                 WRITE(38,'(/,A,/)') ' ================   Half-Sib subset analysis result   =================='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
62                  CALL fcnone2 (NN, x, fvec, arpno, IBDSn2, reln2, eps, IinvU, familyn2, subfamilyn2(typerel(2)), nlocation,  &
                         &     n_location, varp)                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,108) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 73
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-', &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C2 (HS) =', x(2),  &
                               &  '(', x(2)-1.96_dp*se(2), '-', x(2)+1.96_dp*se(2), ')'    
                          lambda1=(1.0_dp+2.0_dp*x(2))/(1.0_dp-2.0_dp*x(2))
                          sel1=((2.0_dp/(1.0_dp-2.0_dp*x(2))+2.0_dp*(1.0_dp+2.0_dp*x(2))/  &
                               &   (1.0_dp-2.0_dp*x(2))**2)**2*varp(2,2))**0.5
                          WRITE(*,800) ' Risk ratio lambda2 (HS) =', MAX(0.0_dp,lambda1),  &
                               &  '(', MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,*)   '            tau      ', '   C2  '
                          WRITE(*,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(*,308) '   C2  ', varp(2,1), varp(2,2)


                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-', &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C2 (HS) =', x(2),  &
                               &  '(', x(2)-1.96_dp*se(2), '-', x(2)+1.96_dp*se(2), ')'    
                          WRITE(38,800) ' Risk ratio lambda2 (HS) =', MAX(0.0_dp,lambda1),  &
                               &  '(', MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,*)   '            tau      ', '   C2  '
                          WRITE(38,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(38,308) '   C2  ', varp(2,1), varp(2,2)
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No disease locus or too poor initial values !'
                          WRITE(38,'(A)') ' No disease locus or too poor initial values !'
                          GO TO 73
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 73
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No disease locus or too poor initial values !'
                             WRITE(38,'(/,A)') ' No disease locus or too poor initial values !'
                             GO TO 73                        
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 62
                    END IF
                 END DO   ! END Fisher's scoring METHOD
73               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn2(typerel(2))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
262                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn2(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn2(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn2(:,j)
                                relb(k)=reln2(j)
                                familyb(k)=familyn2(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1) = xini(1)
                       x(2) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
162                       CALL fcnone2 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                         &     n_location, varp)
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,208) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 262
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 262
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 262                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 162
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO

                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Genetic effect C2 (HS) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')'                       
                    j=2
                    lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                    lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                    upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                    WRITE(*,800) ' Risk ratio lambda2 (HS) =', MAX(0.0_dp,lambda1), '(', MAX(0.0_dp,lower1), '-', upper1, ')'


                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'

                    WRITE(38,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C2 (HS) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')'                       
                    WRITE(38,800) ' Risk ratio lambda2 (HS) =', MAX(0.0_dp,lambda1), '(', MAX(0.0_dp,lower1), '-', upper1, ')'

                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn2)
                 DEALLOCATE(reln2)
                 DEALLOCATE(familyn2tmp)
                 DEALLOCATE(familyn2)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(2) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' ================   Half-Sib subset analysis result   =================='
                 WRITE(*,'(/,A)') ' The number of half-sib pairs is under 15, skip the subset analysis for half sibs !'
                 WRITE(38,'(/,A,/)') ' ================   Half-Sib subset analysis result   =================='
                 WRITE(38,'(/,A)') ' The number of half-sib pairs is under 15, skip the subset analysis for half sibs !'
              END IF
           END IF
           
           
           ! 3. Subset - FC
           IF ( FC .EQ. 1 ) THEN
              IF (typerel(3) .GE. 15) THEN
                 NN = 2    
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn3(n_location,typerel(3)))
                 ALLOCATE(reln3(typerel(3)))
                 ALLOCATE(familyn3tmp(typerel(3)))
                 ALLOCATE(familyn3(typerel(3)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 3) THEN
                       j = j+1
                       IBDSn3(:,j) = IBDSn(:,i)
                       familyn3tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn3(1) = 1
                 DO i=2, typerel(3)
                    IF ( familyn3tmp(i) .NE. familyn3tmp(i-1) ) THEN
                       familyn3(i) = familyn3(i-1)+1
                    ELSE IF ( familyn3tmp(i) .EQ. familyn3tmp(i-1) ) THEN
                       familyn3(i) = familyn3(i-1)
                    END IF
                 END DO
                 x(1) = xini(1)
                 x(2) = xini(3)
                 arpno = typerel(3)
                 reln3 = 3
                 bound(1,1) = nlocation(1)            ! lower bound
                 bound(1,2) = nlocation(n_location)   ! upper bound
                 bound(2,1) = -0.25_dp                ! lower bound
                 bound(2,2) = 0.75_dp                 ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ================   First-Cousin subset analysis result   =================='
                 WRITE(38,'(/,A,/)') ' ================   First-Cousin subset analysis result   =================='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO      ! START Fisher's scoring METHOD
                    iter=0
63                  CALL fcnone3 (NN, x, fvec, arpno, IBDSn3, reln3, eps, IinvU, familyn3, subfamilyn3(typerel(3)), nlocation, &
                         &     n_location, varp)
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,108) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 74
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C3 (FC) =', x(2),  &
                               &  '(', x(2)-1.96_dp*se(2), '-', x(2)+1.96_dp*se(2), ')'    
                          lambda1=(3.0_dp+12.0_dp*x(2))/(3.0_dp-4.0_dp*x(2))
                          sel1=((12.0_dp/(3.0_dp-4.0_dp*x(2))+4.0_dp*(3.0_dp+12.0_dp*x(2))/  &
                               &   (3.0_dp-4.0_dp*x(2))**2)**2*varp(2,2))**0.5
                          WRITE(*,800) ' Risk ratio lambda3 (FC) =', MAX(0.0_dp,lambda1),  &
                               &  '(', MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,*)   '            tau      ', '   C3  '
                          WRITE(*,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(*,308) '   C3  ', varp(2,1), varp(2,2) 


                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C3 (FC) =', x(2),  &
                               &  '(', x(2)-1.96_dp*se(2), '-', x(2)+1.96_dp*se(2), ')'    
                          WRITE(38,800) ' Risk ratio lambda3 (FC) =', MAX(0.0_dp,lambda1),  &
                               &  '(', MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,*)   '            tau      ', '   C3  '
                          WRITE(38,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(38,308) '   C3  ', varp(2,1), varp(2,2) 

                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No disease locus or too poor initial values !'
                          WRITE(38,'(A)') ' No disease locus or too poor initial values !'
                          GO TO 74
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 74
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No disease locus or too poor initial values !'
                             WRITE(38,'(/,A)') ' No disease locus or too poor initial values !'
                             GO TO 74                        
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 63
                    END IF
                 END DO   ! END Fisher's scoring METHOD
74               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn3(typerel(3))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
263                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn3(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn3(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn3(:,j)
                                relb(k)=reln3(j)
                                familyb(k)=familyn3(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1) = xini(1)
                       x(2) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
163                       CALL fcnone3 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                         &     n_location, varp)
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,208) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 263
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 263
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 263                        
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 163
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO

                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Genetic effect C3 (FC) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')'                       
                    j=2
                    lambda1=(3.0_dp+12.0_dp*avexb(j))/(3.0_dp-4.0_dp*avexb(j))
                    lower1=(3.0_dp+12.0_dp*bootCI(j,1))/(3.0_dp-4.0_dp*bootCI(j,1))
                    upper1=(3.0_dp+12.0_dp*bootCI(j,2))/(3.0_dp-4.0_dp*bootCI(j,2))
                    WRITE(*,800) ' Risk ratio lambda3 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'


                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'

                    WRITE(38,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C3 (FC) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')'                       
                    WRITE(38,800) ' Risk ratio lambda3 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'


                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn3)
                 DEALLOCATE(reln3)
                 DEALLOCATE(familyn3tmp)
                 DEALLOCATE(familyn3)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(3) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' ================   First-Cousin subset analysis result   =================='
                 WRITE(*,'(/,A)') ' The number of first-cousin pairs is under 15, skip the subset analysis for first cousins !'
                 WRITE(38,'(/,A,/)') ' ================   First-Cousin subset analysis result   =================='
                 WRITE(38,'(/,A)') ' The number of first-cousin pairs is under 15, skip the subset analysis for first cousins !'
              END IF
           END IF
           
           
           ! 4. Subset - GP
           
           IF ( GP .EQ. 1 ) THEN
              IF (typerel(4) .GE. 15) THEN
                 NN = 2    
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn4(n_location,typerel(4)))
                 ALLOCATE(reln4(typerel(4)))
                 ALLOCATE(familyn4tmp(typerel(4)))
                 ALLOCATE(familyn4(typerel(4)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 4) THEN
                       j = j+1
                       IBDSn4(:,j) = IBDSn(:,i)
                       familyn4tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn4(1) = 1
                 DO i=2, typerel(4)
                    IF ( familyn4tmp(i) .NE. familyn4tmp(i-1) ) THEN
                       familyn4(i) = familyn4(i-1)+1
                    ELSE IF ( familyn4tmp(i) .EQ. familyn4tmp(i-1) ) THEN
                       familyn4(i) = familyn4(i-1)
                    END IF
                 END DO
                 x(1) = xini(1)
                 x(2) = xini(3)
                 arpno = typerel(4)
                 reln4 = 4
                 bound(1,1) = nlocation(1)            ! lower bound
                 bound(1,2) = nlocation(n_location)   ! upper bound
                 bound(2,1) = -0.5_dp                 ! lower bound
                 bound(2,2) = 0.5_dp                  ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ===========   Grandparent-Grandchild subset analysis result   ==========='
                 WRITE(38,'(/,A,/)') ' ===========   Grandparent-Grandchild subset analysis result   ==========='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
64                  CALL fcnone4 (NN, x, fvec, arpno, IBDSn4, reln4, eps, IinvU, familyn4, subfamilyn4(typerel(4)), nlocation,  &
                         &     n_location, varp)
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,108) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 75
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C4 (GP) =', x(2),  &
                               &  '(', x(2)-1.96_dp*se(2), '-', x(2)+1.96_dp*se(2), ')'    
                          lambda1=(1.0_dp+2.0_dp*x(2))/(1.0_dp-2.0_dp*x(2))
                          sel1=((2.0_dp/(1.0_dp-2.0_dp*x(2))+2.0_dp*(1.0_dp+2.0_dp*x(2))/  &
                               &   (1.0_dp-2.0_dp*x(2))**2)**2*varp(2,2))**0.5
                          WRITE(*,800) ' Risk ratio lambda4 (GP) =', MAX(0.0_dp,lambda1), '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,*)   '            tau      ', '   C4  '
                          WRITE(*,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(*,308) '   C4  ', varp(2,1), varp(2,2)  

                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C4 (GP) =', x(2),  &
                               &  '(', x(2)-1.96_dp*se(2), '-', x(2)+1.96_dp*se(2), ')'    
                          WRITE(38,800) ' Risk ratio lambda4 (GP) =', MAX(0.0_dp,lambda1), '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,*)   '            tau      ', '   C4  '
                          WRITE(38,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(38,308) '   C4  ', varp(2,1), varp(2,2)  

                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No disease locus or too poor initial values !'
                          WRITE(38,'(A)') ' No disease locus or too poor initial values !'
                          GO TO 75
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 75
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No disease locus or too poor initial values !'
                             WRITE(38,'(/,A)') ' No disease locus or too poor initial values !'
                             GO TO 75                          
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 64
                    END IF
                 END DO   ! END Fisher's scoring METHOD
75               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn4(typerel(4))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
264                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn4(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn4(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn4(:,j)
                                relb(k)=reln4(j)
                                familyb(k)=familyn4(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1) = xini(1)
                       x(2) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
164                       CALL fcnone4 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                         &     n_location, varp)
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,208) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 264
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 264
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 264                        
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 164
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO

                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Genetic effect C4 (GP) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')'                       
                    j=2
                    lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                    lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                    upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                    WRITE(*,800) ' Risk ratio lambda4 (GP) =', MAX(0.0_dp,lambda1), '(', MAX(0.0_dp,lower1), '-', upper1, ')'


                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'

                    WRITE(38,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C4 (GP) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')'                       
                    WRITE(38,800) ' Risk ratio lambda4 (GP) =', MAX(0.0_dp,lambda1), '(', MAX(0.0_dp,lower1), '-', upper1, ')'


                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn4)
                 DEALLOCATE(reln4)
                 DEALLOCATE(familyn4tmp)
                 DEALLOCATE(familyn4)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(4) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' =========   Grandparent-Grandchild subset analysis result   ========='
                 WRITE(*,'(/,A)') ' The number of grandparent-grandchild pairs is under 15, skip the subset analysis for GP !'
                 WRITE(38,'(/,A,/)') ' =========   Grandparent-Grandchild subset analysis result   ========='
                 WRITE(38,'(/,A)') ' The number of grandparent-grandchild pairs is under 15, skip the subset analysis for GP !'
              END IF
           END IF
           
           
           ! 5. Subset - AP
           
           IF ( AP .EQ. 1 ) THEN
              IF (typerel(5) .GE. 15) THEN
                 NN = 2    
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn5(n_location,typerel(5)))
                 ALLOCATE(reln5(typerel(5)))
                 ALLOCATE(familyn5tmp(typerel(5)))
                 ALLOCATE(familyn5(typerel(5)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 5) THEN
                       j = j+1
                       IBDSn5(:,j) = IBDSn(:,i)
                       familyn5tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn5(1) = 1
                 DO i=2, typerel(5)
                    IF ( familyn5tmp(i) .NE. familyn5tmp(i-1) ) THEN
                       familyn5(i) = familyn5(i-1)+1
                    ELSE IF ( familyn5tmp(i) .EQ. familyn5tmp(i-1) ) THEN
                       familyn5(i) = familyn5(i-1)
                    END IF
                 END DO
                 x(1) = xini(1)
                 x(2) = xini(3)
                 arpno = typerel(5)
                 reln5 = 5
                 bound(1,1) = nlocation(1)            ! lower bound
                 bound(1,2) = nlocation(n_location)   ! upper bound
                 bound(2,1) = -0.5_dp                 ! lower bound
                 bound(2,2) = 0.5_dp                  ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ================   Avuncular-Pair subset analysis result   =================='
                 WRITE(38,'(/,A,/)') ' ================   Avuncular-Pair subset analysis result   =================='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
65                  CALL fcnone5 (NN, x, fvec, arpno, IBDSn5, reln5, eps, IinvU, familyn5, subfamilyn5(typerel(5)), nlocation,  &
                         &     n_location, varp)
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,108) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 76
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C5 (AP) =', x(2),  &
                               &  '(', x(2)-1.96_dp*se(2), '-', x(2)+1.96_dp*se(2), ')'    
                          lambda1=(1.0_dp+2.0_dp*x(2))/(1.0_dp-2.0_dp*x(2))
                          sel1=((2.0_dp/(1.0_dp-2.0_dp*x(2))+2.0_dp*(1.0_dp+2.0_dp*x(2))/  &
                               &   (1.0_dp-2.0_dp*x(2))**2)**2*varp(2,2))**0.5
                          WRITE(*,800) ' Risk ratio lambda5 (AP) =', MAX(0.0_dp,lambda1), '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,*)   '            tau      ', '   C5  '
                          WRITE(*,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(*,308) '   C5  ', varp(2,1), varp(2,2)       


                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C5 (AP) =', x(2),  &
                               &  '(', x(2)-1.96_dp*se(2), '-', x(2)+1.96_dp*se(2), ')'    
                          WRITE(38,800) ' Risk ratio lambda5 (AP) =', MAX(0.0_dp,lambda1), '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,*)   '            tau      ', '   C5  '
                          WRITE(38,308) '  tau  ', varp(1,1), varp(1,2)
                          WRITE(38,308) '   C5  ', varp(2,1), varp(2,2)       
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No disease locus or too poor initial values !'
                          WRITE(38,'(A)') ' No disease locus or too poor initial values !'
                          GO TO 76
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 76
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No disease locus or too poor initial values !'
                             WRITE(38,'(/,A)') ' No disease locus or too poor initial values !'
                             GO TO 76                         
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 65
                    END IF
                 END DO   ! END Fisher's scoring METHOD
76               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn5(typerel(5))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
265                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn5(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn5(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn5(:,j)
                                relb(k)=reln5(j)
                                familyb(k)=familyn5(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1) = xini(1)
                       x(2) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
165                       CALL fcnone5 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                         &     n_location, varp)
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,208) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 265
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 265
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 265                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 165
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO

                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Genetic effect C5 (AP) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')' 
                    j=2
                    lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                    lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                    upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                    WRITE(*,800) ' Risk ratio lambda5 (AP) =', MAX(0.0_dp,lambda1), '(', MAX(0.0_dp,lower1), '-', upper1, ')'


                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'

                    WRITE(38,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C5 (AP) =', avexb(2), '(',bootCI(2,1), '-', bootCI(2,2), ')' 
                    WRITE(38,800) ' Risk ratio lambda5 (AP) =', MAX(0.0_dp,lambda1), '(', MAX(0.0_dp,lower1), '-', upper1, ')'

                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn5)
                 DEALLOCATE(reln5)
                 DEALLOCATE(familyn5tmp)
                 DEALLOCATE(familyn5)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(5) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' ================   Avuncular-Pair subset analysis result   =================='
                 WRITE(*,'(/,A)') ' The number of avuncular pairs is under 15, skip the subset analysis for avuncular pairs !'
                 WRITE(38,'(/,A,/)') ' ================   Avuncular-Pair subset analysis result   =================='
                 WRITE(38,'(/,A)') ' The number of avuncular pairs is under 15, skip the subset analysis for avuncular pairs !'
              END IF
           END IF
        END IF
        
        ! 6. Unconstrained-Model Approach 
        
        IF ( (METHOD .EQ. 'A') .OR. (METHOD .EQ. 'B') ) THEN
           DEALLOCATE(typeno)
           IF (SUM(typereln) .GE. 15) THEN
              cou = 0
              NN = 1
              k = 0
              IF ( (typerel(1) .GE. 15) .AND. (FS .EQ. 1) ) THEN
                 cou = cou+typerel(1)
                 FS = 1
                 NN = NN+1
                 k = k+1
              ELSE
                 FS = 0
              END IF
              IF ( (typerel(2) .GE. 15) .AND. (HS .EQ. 1) ) THEN
                 cou = cou+typerel(2)
                 HS = 1
                 NN = NN+1
                 k = k+1
              ELSE
                 HS = 0
              END IF
              IF ( (typerel(3) .GE. 15) .AND. (FC .EQ. 1) ) THEN
                 cou = cou+typerel(3)
                 FC = 1
                 NN = NN+1
                 k = k+1
              ELSE
                 FC = 0
              END IF
              IF ( (typerel(4) .GE. 15) .AND. (GP .EQ. 1) ) THEN
                 cou = cou+typerel(4)
                 GP = 1
                 NN = NN+1
                 k = k+1
              ELSE
                 GP = 0
              END IF
              IF ( (typerel(5) .GE. 15) .AND. (AP .EQ. 1) ) THEN
                 cou = cou+typerel(5)
                 AP = 1
                 NN = NN+1
                 k = k+1
              ELSE
                 AP = 0 
              END IF

              arpno = cou
              
              ALLOCATE(typeno(k))
              j=0
              IF ( FS .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=1
              END IF
              IF ( HS .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=2
              END IF
              IF ( FC .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=3
              END IF
              IF ( GP .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=4
              END IF
              IF ( AP .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=5
              END IF
              
              ALLOCATE(IBDSnn(n_location,cou))
              ALLOCATE(relnn(cou))
              ALLOCATE(familynntmp(cou))
              ALLOCATE(familynn(cou))
              IF (ifcov .EQ. 'Y') THEN
                 IF ( (FUN .EQ. 'D') .OR. (FUN .EQ. 'C') ) THEN
                    ALLOCATE(arpcovnn(ncov,1,cou))
                 ELSE IF (FUN .EQ. 'B') THEN
                    ALLOCATE(arpcovnn(ncov,2,cou))
                 END IF
              END IF


              j = 0
              DO i=1, SUM(typereln)
                 DO k=1, SIZE(typeno)
                    IF ( reln(i) .EQ. typeno(k) ) THEN
                       j = j+1
                       relnn(j) = reln(i)
                       IBDSnn(:,j) = IBDSn(:,i)
                       familynntmp(j) = familyn(i)
                       IF (ifcov .EQ. 'Y') THEN
                          arpcovnn(:,:,j)=arpcovn(:,:,i)
                       END IF
                    END IF
                 END DO
              END DO


              familynn(1) = 1
              DO i=2, cou
                 IF ( familynntmp(i) .NE. familynntmp(i-1) ) THEN
                    familynn(i) = familynn(i-1)+1
                 ELSE IF ( familynntmp(i) .EQ. familynntmp(i-1) ) THEN
                    familynn(i) = familynn(i-1) 
                 END IF
              END DO


              IF ( (constrained .EQ. 'U') .OR. (constrained .EQ. 'B') ) THEN

                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))


                 x(1) = xini(1)
                 x(2:NN) = xini(3)
                 bound(1,1) = nlocation(1)             ! lower bound
                 bound(1,2) = nlocation(n_location)    ! upper bound
                 j=0
                 IF ( FS .EQ. 1 ) THEN
                    j=j+1
                    bound(j+1,1) = -1.0_dp               ! lower bound
                    bound(j+1,2) = 0.5_dp                ! upper bound
                 END IF
                 IF ( HS .EQ. 1 ) THEN
                    j=j+1
                    bound(j+1,1) = -0.5_dp               ! lower bound
                    bound(j+1,2) = 0.5_dp                ! upper bound
                 END IF
                 IF ( FC .EQ. 1 ) THEN
                    j=j+1
                    bound(j+1,1) = -0.25_dp              ! lower bound
                    bound(j+1,2) = 0.75_dp               ! upper bound
                 END IF
                 IF ( GP .EQ. 1 ) THEN
                    j=j+1
                    bound(j+1,1) = -0.5_dp               ! lower bound
                    bound(j+1,2) = 0.5_dp                ! upper bound
                 END IF
                 IF ( AP .EQ. 1 ) THEN
                    j=j+1
                    bound(j+1,1) = -0.5_dp               ! lower bound
                    bound(j+1,2) = 0.5_dp                ! upper bound
                 END IF
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ===========   Unconstrained-Model Approach analysis result   ============='
                 WRITE(38,'(/,A,/)') ' ===========   Unconstrained-Model Approach analysis result   ============='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
66                  CALL fcnone (NN, x, fvec, arpno, IBDSnn, relnn, eps, IinvU, familynn, familynn(arpno), nlocation, n_location,  &
                         &    varp, typeno, SIZE(typeno) )
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    
                    SELECT CASE (SIZE(typeno))
                    CASE (1)
                       WRITE(38,108) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                    CASE (2)
                       WRITE(38,112) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:NN), 'sta=', sta
                    CASE (3)
                       WRITE(38,113) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:NN), 'sta=', sta
                    CASE (4)
                       WRITE(38,114) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:NN), 'sta=', sta
                    CASE (5)
                       WRITE(38,115) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:NN), 'sta=', sta
                    END SELECT
                    
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 77
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'

                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          j=1
                          IF ( FS .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C1 (FS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C1 (FS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          IF ( HS .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C2 (HS) =', x(j), &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C2 (HS) =', x(j), &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          IF ( FC .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C3 (FC) =', x(j), &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C3 (FC) =', x(j), &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          IF ( GP .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C4 (GP) =', x(j), &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C4 (GP) =', x(j), &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          IF ( AP .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C5 (AP) =', x(j), &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C5 (AP) =', x(j), &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          
                          
                          j=1
                          IF ( FS .EQ. 1 ) THEN
                             j=j+1
                             lambda1=1.0_dp/(1.0_dp-2.0_dp*x(j))
                             sel1=((2.0_dp/(1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda1 (FS) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             WRITE(38,800) ' Risk ratio lambda1 (FS) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          END IF
                          IF ( HS .EQ. 1 ) THEN
                             j=j+1
                             lambda1=(1.0_dp+2.0_dp*x(j))/(1.0_dp-2.0_dp*x(j))
                             sel1=((2.0_dp/(1.0_dp-2.0_dp*x(j))+2.0_dp*(1.0_dp+2.0_dp*x(j))/  &
                                  &   (1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda2 (HS) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             WRITE(38,800) ' Risk ratio lambda2 (HS) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          END IF
                          IF ( FC .EQ. 1 ) THEN
                             j=j+1
                             lambda1=(3.0_dp+12.0_dp*x(j))/(3.0_dp-4.0_dp*x(j))
                             sel1=((12.0_dp/(3.0_dp-4.0_dp*x(j))+4.0_dp*(3.0_dp+12.0_dp*x(j))/  &
                                  &   (3.0_dp-4.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda3 (FC) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                             WRITE(38,800) ' Risk ratio lambda3 (FC) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                          END IF
                          IF ( GP .EQ. 1 ) THEN
                             j=j+1
                             lambda1=(1.0_dp+2.0_dp*x(j))/(1.0_dp-2.0_dp*x(j))
                             sel1=((2.0_dp/(1.0_dp-2.0_dp*x(j))+2.0_dp*(1.0_dp+2.0_dp*x(j))/  &
                                  &   (1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda4 (GP) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                             WRITE(38,800) ' Risk ratio lambda4 (GP) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                          END IF
                          IF ( AP .EQ. 1 ) THEN
                             j=j+1
                             lambda1=(1.0_dp+2.0_dp*x(j))/(1.0_dp-2.0_dp*x(j))
                             sel1=((2.0_dp/(1.0_dp-2.0_dp*x(j))+2.0_dp*(1.0_dp+2.0_dp*x(j))/  &
                                  &   (1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda5 (AP) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                             WRITE(38,800) ' Risk ratio lambda5 (AP) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')'
                          END IF
                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          SELECT CASE (SIZE(typeno))
                          CASE (1)
                             WRITE(*,'(2A,I1)')   '            tau      ', '   C', typeno(1)
                             WRITE(*,308) '  tau  ', varp(:,1)
                             WRITE(*,'(A,I1,2X,2F12.8)') '   C', typeno(1), varp(:,2)

                             WRITE(38,'(2A,I1)')   '            tau      ', '   C', typeno(1)
                             WRITE(38,308) '  tau  ', varp(:,1)
                             WRITE(38,'(A,I1,2X,2F12.8)') '   C', typeno(1), varp(:,2)
                          CASE (2)
                             WRITE(*,'(A,2(A,I1,4X))')   '            tau      ', '   C', typeno(1), '   C', typeno(2)
                             WRITE(*,312) '  tau  ', varp(:,1)
                             WRITE(*,'(A,I1,2X,3F12.8)') '   C', typeno(1), varp(:,2)
                             WRITE(*,'(A,I1,2X,3F12.8)') '   C', typeno(2), varp(:,3)

                             WRITE(38,'(A,2(A,I1,4X))')   '            tau      ', '   C', typeno(1), '   C', typeno(2)
                             WRITE(38,312) '  tau  ', varp(:,1)
                             WRITE(38,'(A,I1,2X,3F12.8)') '   C', typeno(1), varp(:,2)
                             WRITE(38,'(A,I1,2X,3F12.8)') '   C', typeno(2), varp(:,3)
                          CASE (3)
                             WRITE(*,'(A,3(A,I1,4X))')   '            tau      ', '    C', typeno(1), '     C', typeno(2),   &
                                  &  '     C', typeno(3)
                             WRITE(*,313) '  tau  ', varp(:,1)
                             WRITE(*,'(A,I1,2X,4F12.8)') '   C', typeno(1), varp(:,2)
                             WRITE(*,'(A,I1,2X,4F12.8)') '   C', typeno(2), varp(:,3)
                             WRITE(*,'(A,I1,2X,4F12.8)') '   C', typeno(3), varp(:,4)

                             WRITE(38,'(A,3(A,I1,4X))')   '            tau      ', '    C', typeno(1), '     C', typeno(2),   &
                                  &  '     C', typeno(3)
                             WRITE(38,313) '  tau  ', varp(:,1)
                             WRITE(38,'(A,I1,2X,4F12.8)') '   C', typeno(1), varp(:,2)
                             WRITE(38,'(A,I1,2X,4F12.8)') '   C', typeno(2), varp(:,3)
                             WRITE(38,'(A,I1,2X,4F12.8)') '   C', typeno(3), varp(:,4)
                          CASE (4)
                             WRITE(*,'(A,4(A,I1,4X))')   '            tau      ', '    C', typeno(1), '    C', typeno(2),   &
                                  &  '     C', typeno(3), '     C', typeno(4)
                             WRITE(*,314) '  tau  ', varp(:,1)
                             WRITE(*,'(A,I1,2X,5F12.8)') '   C', typeno(1), varp(:,2)
                             WRITE(*,'(A,I1,2X,5F12.8)') '   C', typeno(2), varp(:,3)
                             WRITE(*,'(A,I1,2X,5F12.8)') '   C', typeno(3), varp(:,4)
                             WRITE(*,'(A,I1,2X,5F12.8)') '   C', typeno(4), varp(:,5)

                             WRITE(38,'(A,4(A,I1,4X))')   '            tau      ', '    C', typeno(1), '     C', typeno(2),   &
                                  &  '     C', typeno(3), '     C', typeno(4)
                             WRITE(38,314) '  tau  ', varp(:,1)
                             WRITE(38,'(A,I1,2X,5F12.8)') '   C', typeno(1), varp(:,2)
                             WRITE(38,'(A,I1,2X,5F12.8)') '   C', typeno(2), varp(:,3)
                             WRITE(38,'(A,I1,2X,5F12.8)') '   C', typeno(3), varp(:,4)
                             WRITE(38,'(A,I1,2X,5F12.8)') '   C', typeno(4), varp(:,5)
                          CASE (5)
                             WRITE(*,'(A,5(A,I1,4X))')   '            tau      ', '    C', typeno(1), '     C', typeno(2),   &
                                  &  '     C', typeno(3), '     C', typeno(4), '     C', typeno(5)
                             WRITE(*,315) '  tau  ', varp(:,1)
                             WRITE(*,'(A,I1,2X,6F12.8)') '   C', typeno(1), varp(:,2)
                             WRITE(*,'(A,I1,2X,6F12.8)') '   C', typeno(2), varp(:,3)
                             WRITE(*,'(A,I1,2X,6F12.8)') '   C', typeno(3), varp(:,4)
                             WRITE(*,'(A,I1,2X,6F12.8)') '   C', typeno(4), varp(:,5)
                             WRITE(*,'(A,I1,2X,6F12.8)') '   C', typeno(5), varp(:,6)

                             WRITE(38,'(A,5(A,I1,4X))')   '            tau      ', '    C', typeno(1), '     C', typeno(2),   &
                                  &  '     C', typeno(3), '     C', typeno(4), '     C', typeno(5)
                             WRITE(38,315) '  tau  ', varp(:,1)
                             WRITE(38,'(A,I1,2X,6F12.8)') '   C', typeno(1), varp(:,2)
                             WRITE(38,'(A,I1,2X,6F12.8)') '   C', typeno(2), varp(:,3)
                             WRITE(38,'(A,I1,2X,6F12.8)') '   C', typeno(3), varp(:,4)
                             WRITE(38,'(A,I1,2X,6F12.8)') '   C', typeno(4), varp(:,5)
                             WRITE(38,'(A,I1,2X,6F12.8)') '   C', typeno(5), varp(:,6)
                          END SELECT
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No disease locus or too poor initial values !'
                          WRITE(*,'(A)') ' Look into the constrained-model approach ... '

                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(A)') ' No disease locus or too poor initial values !'
                          WRITE(38,'(A)') ' Look into the constrained-model approach ... '

                          GO TO 77
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter1 ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter1, 'iterations !'
                          WRITE(*,'(/,A)') ' Look into the constrained-model approach ... '

                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter1, 'iterations !'
                          WRITE(38,'(/,A)') ' Look into the constrained-model approach ... '
                          GO TO 77
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No disease locus or too poor initial values !'
                             WRITE(38,'(/,A)') ' No disease locus or too poor initial values !'
                             GO TO 77                          
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 66
                    END IF
                 END DO   ! END Fisher's scoring METHOD
                 

              
77               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=familynn(arpno)
                    kind=SIZE(typeno)
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
266                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familynn(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familynn(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSnn(:,j)
                                relb(k)=relnn(j)
                                familyb(k)=familynn(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1) = xini(1)
                       x(2:NN) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
166                       CALL fcnone (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n,  & 
                               &  nlocation, n_location, varp, typeno, SIZE(typeno) )
                          
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                       
                          SELECT CASE (kind)
                          CASE (1)
                             WRITE(38,208) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                          CASE (2)
                             WRITE(38,212) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:NN), 'sta=', sta
                          CASE (3)
                             WRITE(38,213) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:NN), 'sta=', sta
                          CASE (4)
                             WRITE(38,214) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:NN), 'sta=', sta
                          CASE (5)
                             WRITE(38,215) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:NN), 'sta=', sta
                          END SELECT
                          
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 266
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 266
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 266                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 166
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO
                    
                    ! Sorting 
                 
                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO
                    
                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO
                    
                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'
                    
                    WRITE(*,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'

                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'
                    
                    WRITE(38,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    
                    j=1
                    IF ( FS .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C1 (FS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C1 (FS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                    IF ( HS .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C2 (HS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C2 (HS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                    IF ( FC .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C3 (FC) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C3 (FC) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                    IF ( GP .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C4 (GP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C4 (GP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                    IF ( AP .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C5 (AP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C5 (AP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                    
                    j=1
                    IF ( FS .EQ. 1 ) THEN
                       j=j+1
                       lambda1=1.0_dp/(1.0_dp-2.0_dp*avexb(j))
                       lower1=1.0_dp/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=1.0_dp/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda1 (FS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda1 (FS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    IF ( HS .EQ. 1 ) THEN
                       j=j+1
                       lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                       lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda2 (HS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda2 (HS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    IF ( FC .EQ. 1 ) THEN
                       j=j+1
                       lambda1=(3.0_dp+12.0_dp*avexb(j))/(3.0_dp-4.0_dp*avexb(j))
                       lower1=(3.0_dp+12.0_dp*bootCI(j,1))/(3.0_dp-4.0_dp*bootCI(j,1))
                       upper1=(3.0_dp+12.0_dp*bootCI(j,2))/(3.0_dp-4.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda3 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda3 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    IF ( GP .EQ. 1 ) THEN
                       j=j+1
                       lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                       lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda4 (GP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda4 (GP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    IF ( AP .EQ. 1 ) THEN
                       j=j+1
                       lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                       lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda5 (AP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda5 (AP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    
                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper) 

              END IF


              ! 7. Constrained-Model Approach 

              IF ( (constrained .EQ. 'C') .OR. (constrained .EQ. 'B') ) THEN

                 NN=2
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 
                 
                 x(1) = xini(1)
                 x(2) = 1.0_dp/(1.0_dp-2.0_dp*xini(3))
                 bound(1,1) = nlocation(1)             ! lower bound
                 bound(1,2) = nlocation(n_location)    ! upper bound
                 bound(2,1) = 0.0_dp                   ! lower bound
                 bound(2,2) = 1000.0_dp                ! upper bound
                 x_lower = -20.0_dp
                 x_upper = 100.0_dp
                 WRITE(*,'(/,A)') ' =============   Constrained-Model Approach analysis result   ==============='
                 WRITE(38,'(/,A)') ' =============   Constrained-Model Approach analysis result   ==============='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
67                  CALL fcnonec (NN, x, fvec, arpno, IBDSnn, relnn, eps, IinvU, familynn, familynn(arpno),  &
                         &  nlocation, n_location, varp, typeno, SIZE(typeno) )
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,108) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 78
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Common risk ratio lambda =', x(2),  &
                               &  '(', MAX(0.0_dp,x(2)-1.96_dp*se(2)), '-', x(2)+1.96_dp*se(2), ')'  
                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,'(2A)')   '            tau      ', '   lambda    '
                          WRITE(*,308) '  tau    ', varp(:,1)
                          WRITE(*,308) ' lambda  ', varp(:,2)


                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Common risk ratio lambda =', x(2),  &
                               &  '(', MAX(0.0_dp,x(2)-1.96_dp*se(2)), '-', x(2)+1.96_dp*se(2), ')'  
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,'(2A)')   '            tau      ', '   lambda    '
                          WRITE(38,308) '  tau    ', varp(:,1)
                          WRITE(38,308) ' lambda  ', varp(:,2)

                          NN=SIZE(typeno)+1
                          ALLOCATE(xcon(NN))
                          xcon=0.0_dp
                          xcon(1)=x(1)
                          j=1                       
                          DO k=1, SIZE(typeno)
                             DO i=1, 5
                                IF ( i .EQ. typeno(k) ) THEN
                                   SELECT CASE ( i )
                                   CASE (1)
                                      j=j+1
                                      xcon(j)=(x(2)-1.0_dp)/(2.0_dp*x(2))
                                   CASE (2)
                                      j=j+1
                                      xcon(j)=(x(2)-1.0_dp)/(2.0_dp*x(2)+2.0_dp)
                                   CASE (3)
                                      j=j+1
                                      xcon(j)=(3.0_dp*x(2)-3.0_dp)/(4.0_dp*x(2)+12.0_dp)
                                   CASE (4)
                                      j=j+1
                                      xcon(j)=(x(2)-1.0_dp)/(2.0_dp*x(2)+2.0_dp)
                                   CASE (5)
                                      j=j+1
                                      xcon(j)=(x(2)-1.0_dp)/(2.0_dp*x(2)+2.0_dp)
                                   END SELECT
                                END IF
                             END DO
                          END DO
                          CALL fcnones (NN, xcon, arpno, IBDSnn, relnn, eps, familynn, familynn(arpno),  &
                               &  nlocation, n_location, TT, typeno, SIZE(typeno) )
                          DEALLOCATE(xcon)
                          WRITE(*,'(/,A,1X,F7.3,2X,A,I3)') ' Score statistic for testing homogeneity =', TT, &
                               &  'with df =', SIZE(typeno)-1
                          WRITE(38,'(/,A,1X,F7.3,2X,A,I3)') ' Score statistic for testing homogeneity =', TT, &
                               &  'with df =', SIZE(typeno)-1
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No disease locus or too poor initial values !'
                          WRITE(38,'(A)') ' No disease locus or too poor initial values !'
                          GO TO 78
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 78
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No disease locus or too poor initial values !'
                             WRITE(38,'(/,A)') ' No disease locus or too poor initial values !'
                             GO TO 78                          
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 67
                    END IF
                 END DO   ! END Fisher's scoring METHOD
                 
78               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    NN=2
                    n=familynn(arpno)
                    kind=SIZE(typeno)
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
267                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familynn(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familynn(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSnn(:,j)
                                relb(k)=relnn(j)
                                familyb(k)=familynn(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1) = xini(1)
                       x(2) = 1.0_dp/(1.0_dp-2.0_dp*xini(3))
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
167                       CALL fcnonec (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n,  &
                               nlocation, n_location, varp, typeno, SIZE(typeno) )
                          
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          
                          WRITE(38,208) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2), 'sta=', sta
                          
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 267
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 267
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 267                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 167
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO
                    
                    ! Sorting 
                    
                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO
                 
                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO
                    

                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'
                    
                    WRITE(*,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    
                    WRITE(*,800) ' Common risk ratio lambda =', avexb(2),  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)), '-', bootCI(2,2), ')'  


                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'
                    
                    WRITE(38,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    
                    WRITE(38,800) ' Common risk ratio lambda =', avexb(2),  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)), '-', bootCI(2,2), ')'  
                    
                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)

                 ! Covariates

                 IF (ifcov .EQ. 'Y') THEN
                    WRITE(*,'(/,A)') ' =============   Constrained-Model Incorporating Covariates   ==============='
                    WRITE(38,'(/,A)') ' =============   Constrained-Model Incorporating Covariates   ==============='
                    IF ( (FUN .EQ. 'D') .OR. (FUN .EQ. 'B') ) THEN
                       n_fun=1
                       NN=2+n_fun
                       DO cc=1, ncov
                          ALLOCATE(x(NN))
                          ALLOCATE(fvec(NN))
                          ALLOCATE(IinvU(NN))
                          ALLOCATE(varp(NN,NN))
                          ALLOCATE(se(NN))
                          ALLOCATE(bound(NN,2))
                          ALLOCATE(x_lower(NN))
                          ALLOCATE(x_upper(NN))
                          
                          ALLOCATE(covariate(arpno))
                          covariate(:)=arpcovnn(cc,1,:)     
                          
                          x(1) = xini(1)
                          x(2) = 1.0_dp/(1.0_dp-2.0_dp*xini(3))
                          x(3) = 0.5_dp
                          bound(1,1) = nlocation(1)             ! lower bound
                          bound(1,2) = nlocation(n_location)    ! upper bound
                          bound(2,1) = 0.0_dp                   ! lower bound
                          bound(2,2) = 1000.0_dp                ! upper bound
                          bound(3,1) = -10000.0_dp
                          bound(3,2) = 10000.0_dp
                          x_lower = -200.0_dp
                          x_upper = 1000.0_dp
                          WRITE(*,'(/,A)') ' =============   Constrained-Model Incorporating Covariates   ==============='
                          WRITE(38,'(/,A)') ' =============   Constrained-Model Incorporating Covariates   ==============='
                          oldx2 = 0.0_dp
                          oldx1 = 0.0_dp
                          DO       ! START Fisher's scoring METHOD
                             iter=0
567                          CALL fcnonecx (NN, x, fvec, arpno, IBDSnn, relnn, eps, IinvU, familynn, familynn(arpno),  &
                                  &  nlocation, n_location, varp, typeno, SIZE(typeno), covariate )
                             
                             sta=0.0_dp
                             DO i=1, NN
                                sta=sta+abs(fvec(i))
                             END DO
                             WRITE(38,112) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:3), 'sta=', sta
                             IF(sta .LT. tolimit) THEN
                                cou=0
                                DO i=1, NN
                                   IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                      cou=cou+1
                                   ELSE 
                                      cou=cou
                                   END IF
                                END DO
                                IF ( cou .EQ. NN ) THEN
                                   !              point(1:NN,rr)=x(1:NN)
                                   DO k=1, NN
                                      IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                         se(k)=varp(k,k)**0.5
                                      ELSE
                                         WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                         GO TO 578
                                      END IF
                                   END DO
                                   !              rose(1:NN,rr)=se(1:NN)
                                   WRITE(*,*) ' ==============   ', cov(cc), '  ================' 
                                   WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                                   WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                                   WRITE(*,700) ' Location for tau  =', x(1)*100.0_dp,  &
                                        &  '(', x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp, '-',  &
                                        &       x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp, ') cM.'
                                   WRITE(*,800) ' Common risk ratio lambda, a =', x(2),  &
                                        &  '(', x(2)-1.96_dp*se(2), '-', x(2)+1.96_dp*se(2), ')'  
                                   WRITE(*,800) ' Common risk ratio lambda, b =', x(3),  &
                                        &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'  
                                   WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                                   WRITE(*,'(2A)')   '            tau      ', '    a    ', '    b    '
                                   WRITE(*,312) '  tau    ', varp(:,1)
                                   WRITE(*,312) '   a     ', varp(:,2)
                                   WRITE(*,312) '   b     ', varp(:,3)
                                   EXIT
                                ELSE
                                   WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                                   GO TO 578
                                END IF
                             ELSE
                                iter=iter+1           
                                IF ( iter>maxiter ) THEN
                                   WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                                   GO TO 578
                                END IF
                                oldx2 = oldx1
                                oldx1 = x(1)
                                IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                   DO i=1, NN
                                      x(i)=x(i)+IinvU(i)*0.5
                                   END DO
                                ELSE
                                   DO i=1, NN
                                      x(i)=x(i)+IinvU(i)
                                   END DO
                                END IF
                                DO i=1, NN
                                   IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR.  &
                                        &  ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                                      WRITE(*,'(/,A)') ' No disease locus or too poor initial values !'
                                      GO TO 578                          
                                   END IF
                                END DO
                                fvec=0.0_dp
                                IinvU=0.0_dp
                                GO TO 567
                             END IF
                          END DO   ! END Fisher's scoring METHOD
                          
578                       IF (BS .EQ. 'Y') THEN
                             WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                             WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                             
                             n=familynn(arpno)
                             kind=SIZE(typeno)
                             ALLOCATE(boot(n))
                             ALLOCATE(uuu(n))
                             ALLOCATE(point(NN,bootno))                    
                             bootco=1
                             DO 
                                IF (bootco>bootno) THEN
                                   EXIT
                                END IF
                                WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
767                             CALL RANDOM_SEED
                                CALL RANDOM_NUMBER(uuu) 
                                boot=CEILING(REAL(n)*uuu)
                                arpbo=0
                                DO i=1, n
                                   DO j=1, arpno
                                      IF ( familynn(j) .EQ. boot(i) ) THEN
                                         arpbo=arpbo+1
                                      END IF
                                   END DO
                                END DO
                                ALLOCATE(IBDSb(n_location,arpbo))
                                ALLOCATE(relb(arpbo))
                                ALLOCATE(familyb(arpbo))
                                ALLOCATE(nfamilyb(arpbo))
                                ALLOCATE(covariateb(arpbo))
                                k=0
                                DO i=1, n
                                   DO j=1, arpno
                                      IF ( familynn(j) .EQ. boot(i) ) THEN
                                         k=k+1
                                         IBDSb(:,k)=IBDSnn(:,j)
                                         relb(k)=relnn(j)
                                         familyb(k)=familynn(j)   
                                         nfamilyb(k)=i
                                      END IF
                                   END DO
                                END DO
                          
                                x(1) = xini(1)
                                x(2) = 1.0_dp/(1.0_dp-2.0_dp*xini(3))
                                x(3) = 0.5_dp
                                oldx2 = 0.0_dp
                                oldx1 = 0.0_dp
                                DO       ! START Fisher's scoring METHOD
                                   iter=0
667                                CALL fcnonecx (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n,  &
                                        nlocation, n_location, varp, typeno, SIZE(typeno), covariateb )
                                   
                                   sta=0.0_dp
                                   DO i=1, NN
                                      sta=sta+abs(fvec(i))
                                   END DO
                                   
                                   WRITE(38,212) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2:NN), 'sta=', sta
                                   
                                   IF(sta .LT. tolimit) THEN
                                      cou=0
                                      DO i=1, NN
                                         IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                            cou=cou+1
                                         ELSE 
                                            cou=cou
                                         END IF
                                      END DO
                                      IF ( cou .EQ. NN ) THEN
                                         point(1:NN,bootco)=x(1:NN)
                                         bootco=bootco+1
                                         DEALLOCATE(IBDSb)
                                         DEALLOCATE(relb)
                                         DEALLOCATE(familyb)
                                         DEALLOCATE(nfamilyb)
                                         EXIT
                                      ELSE
                                         DEALLOCATE(IBDSb)
                                         DEALLOCATE(relb)
                                         DEALLOCATE(familyb)
                                         DEALLOCATE(nfamilyb)
                                         GO TO 767
                                      END IF
                                   ELSE
                                      iter=iter+1           
                                      IF ( iter>maxiter ) THEN
                                         DEALLOCATE(IBDSb)
                                         DEALLOCATE(relb)
                                         DEALLOCATE(familyb)
                                         DEALLOCATE(nfamilyb)
                                         GO TO 767
                                      END IF
                                      oldx2 = oldx1
                                      oldx1 = x(1)
                                      IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                         DO i=1, NN
                                            x(i)=x(i)+IinvU(i)*0.5
                                         END DO
                                      ELSE
                                         DO i=1, NN
                                            x(i)=x(i)+IinvU(i)
                                         END DO
                                      END IF
                                      DO i=1, NN
                                         IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR.  &
                                            & ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                            &  THEN
                                            DEALLOCATE(IBDSb)
                                            DEALLOCATE(relb)
                                            DEALLOCATE(familyb)
                                            DEALLOCATE(nfamilyb)
                                            GO TO 767                         
                                         END IF
                                      END DO
                                      fvec=0.0_dp
                                      IinvU=0.0_dp
                                      GO TO 667
                                   END IF
                                END DO   ! END Fisher's scoring METHOD
                             END DO   ! End bootstrap loop
                             ! Summarize the bootstrap results
                             ALLOCATE(avexb(NN))
                             ALLOCATE(temppoint(NN,bootno))
                             ALLOCATE(bootCI(NN,2))
                             DO i=1, NN
                                avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                             END DO
                    
                             ! Sorting 
                             
                             DO i=1, NN
                                temppoint(i,1:bootno)=point(i,1:bootno)
                                DO j=1, (bootno-1)
                                   tp=MINVAL(temppoint(i,j:bootno))
                                   temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                                   temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                                   temppoint(i,j)=tp
                                END DO
                             END DO
                             
                             DO i=1, NN
                                bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                                bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                             END DO
                             
                             WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', &
                                  &  bootno, ' bootstrap samples :'
                    
                             WRITE(*,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                                  &  '(', bootCI(1,1)*100.0_dp, '-', bootCI(1,2)*100.0_dp, ') cM.'
                             
                             WRITE(*,800) ' Common risk ratio lambda, a =', avexb(2),  &
                                  &  '(', bootCI(2,1), '-', bootCI(2,2), ')' 

                             WRITE(*,800) ' Common risk ratio lambda, b =', avexb(3),  &
                                  &  '(', bootCI(3,1), '-', bootCI(3,2), ')'  

                      
                             DEALLOCATE(avexb)
                             DEALLOCATE(temppoint)
                             DEALLOCATE(bootCI)
                             DEALLOCATE(boot)
                             DEALLOCATE(uuu)
                             DEALLOCATE(point)
                    
                          END IF

                          DEALLOCATE(x)
                          DEALLOCATE(fvec)
                          DEALLOCATE(IinvU)
                          DEALLOCATE(varp)
                          DEALLOCATE(se)
                          DEALLOCATE(bound)
                          DEALLOCATE(x_lower)
                          DEALLOCATE(x_upper)
                          DEALLOCATE(covariate)

                       END DO

                    END IF
                    IF ( (FUN .EQ. 'C') .OR. (FUN .EQ. 'B') ) THEN

                    END IF
                 END IF    ! End ifcov
                 
              END IF
                 
              DEALLOCATE(IBDSnn)
              DEALLOCATE(relnn)
              DEALLOCATE(familynntmp)
              DEALLOCATE(familynn)  
           ELSE IF (SUM(typereln) .LT. 15) THEN
              WRITE(*,'(/,A,/)') ' ===   Unconstrained and constrained-Model Approach analysis result   ==='
              WRITE(*,'(/,A)') ' The number of ARPs is under 15, skip unconstrained and constrained-model approach analysis !'
           END IF
        END IF
     END IF
        
        


     IF ( (MODEL .EQ. 'B') .OR. (MODEL .EQ. '2') ) THEN

        WRITE(*,'(/,A,/)') ' ====== Fit a two-locus model, randomly select the initial values ====== '
        WRITE(*,'(A,I3,2X,A,/)') ' ==================  INITIAL VALUES TEST ', ini+1, ' ================== ' 

        WRITE(38,'(/,A,/)') ' ====== Fit a two-locus model, randomly select the initial values ====== '
        WRITE(38,'(A,I3,2X,A,/)') ' ==================  INITIAL VALUES TEST ', ini+1, ' ================== ' 

        
        CALL RANDOM_SEED
        CALL RANDOM_NUMBER(uu)    
        xini(1) = (nlocation(n_location)/2.0_dp)*uu
        x1tmp = xini(1)*100.0_dp
        
        CALL RANDOM_SEED
        CALL RANDOM_NUMBER(uu)    
        xini(2) = (nlocation(n_location)/2.0_dp)*(1.0_dp+uu)
        x2tmp = xini(2)*100.0_dp
        
!        CALL RANDOM_SEED
!        CALL RANDOM_NUMBER(uu)  
        xini(3) = 0.1_dp
        
        WRITE(*,'(A,2X,F7.3,2X,A)') ' Randomly select the initial value for location of first gene to be', x1tmp, 'cM.'
        WRITE(*,'(A,2X,F7.3,2X,A)') ' Randomly select the initial value for location of second gene to be', x2tmp, 'cM.'
        WRITE(*,'(A,2X,F7.3)') ' The initial value of genetic effects for all kinds of ARPs is set at', xini(3)

        WRITE(38,'(A,2X,F7.3,2X,A)') ' Randomly select the initial value for location of first gene to be', x1tmp, 'cM.'
        WRITE(38,'(A,2X,F7.3,2X,A)') ' Randomly select the initial value for location of second gene to be', x2tmp, 'cM.'
        WRITE(38,'(A,2X,F7.3)') ' The initial value of genetic effects for all kinds of ARPs is set at', xini(3)

        
        IF ( (METHOD .EQ. 'S') .OR. (METHOD .EQ. 'B') ) THEN

        
           ! 1. Subset - FS
           IF ( FS .EQ. 1) THEN
              IF (typerel(1) .GE. 15) THEN
                 NN = 4    
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn1(n_location,typerel(1)))
                 ALLOCATE(reln1(typerel(1)))
                 ALLOCATE(familyn1tmp(typerel(1)))
                 ALLOCATE(familyn1(typerel(1)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 1) THEN
                       j = j+1
                       IBDSn1(:,j) = IBDSn(:,i)
                       familyn1tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn1(1) = 1
                 DO i=2, typerel(1)
                    IF ( familyn1tmp(i) .NE. familyn1tmp(i-1) ) THEN
                       familyn1(i) = familyn1(i-1)+1
                    ELSE IF ( familyn1tmp(i) .EQ. familyn1tmp(i-1) ) THEN
                       familyn1(i) = familyn1(i-1)
                    END IF
                 END DO
                 x(1:2) = xini(1:2)
                 x(3:4) = xini(3)
                 arpno = typerel(1)
                 reln1 = 1
                 bound(1:2,1) = nlocation(1)             ! lower bound
                 bound(1:2,2) = nlocation(n_location)    ! upper bound
                 bound(3:NN,1) = -1.0_dp                 ! lower bound
                 bound(3:NN,2) = 0.5_dp                  ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ================   Full-Sib subset analysis result   =================='
                 WRITE(38,'(/,A,/)') ' ================   Full-Sib subset analysis result   =================='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
91                  CALL fcn1 (NN, x, fvec, arpno, IBDSn1, reln1, eps, IinvU, familyn1, subfamilyn1(typerel(1)), nlocation, &
                         &     n_location, varp)
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    
                    WRITE(38,113) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
!                    WRITE(*,113) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                WRITE(38,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 82
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.' 
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C11 (FS) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(*,800) ' Genetic effect C21 (FS) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          lambda1=1.0_dp/(1.0_dp-2.0_dp*x(3))
                          sel1=((2.0_dp/(1.0_dp-2.0_dp*x(3))**2)**2*varp(3,3))**0.5
                          lambda2=1.0_dp/(1.0_dp-2.0_dp*x(4))
                          sel2=((2.0_dp/(1.0_dp-2.0_dp*x(4))**2)**2*varp(4,4))**0.5
                          WRITE(*,800) ' Risk ratio lambda11 (FS) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(*,800) ' Risk ratio lambda21 (FS) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 

                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,'(4A)')   '             tau1      ', '    tau2    ', '    C11   ', '     C21   '
                          WRITE(*,313) '   tau1 ', varp(:,1)
                          WRITE(*,313) '   tau2 ', varp(:,2)
                          WRITE(*,313) '    C11 ', varp(:,3)
                          WRITE(*,313) '    C21 ', varp(:,4)


                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.' 
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C11 (FS) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(38,800) ' Genetic effect C21 (FS) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          WRITE(38,800) ' Risk ratio lambda11 (FS) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(38,800) ' Risk ratio lambda21 (FS) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 

                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,'(4A)')   '             tau1      ', '    tau2    ', '    C11   ', '     C21   '
                          WRITE(38,313) '   tau1 ', varp(:,1)
                          WRITE(38,313) '   tau2 ', varp(:,2)
                          WRITE(38,313) '    C11 ', varp(:,3)
                          WRITE(38,313) '    C21 ', varp(:,4)
             
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No two disease genes or too poor initial values !'
                          WRITE(38,'(A)') ' No two disease genes or too poor initial values !'
                          GO TO 82
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 82
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No two disease genes or too poor initial values !'
                             WRITE(38,'(/,A)') ' No two disease genes or too poor initial values !'
                             GO TO 82                          
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 91
                    END IF
                 END DO   ! END Fisher's scoring METHOD
82               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn1(typerel(1))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
461                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn1(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn1(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn1(:,j)
                                relb(k)=reln1(j)
                                familyb(k)=familyn1(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1:2) = xini(1:2)
                       x(3:4) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
361                       CALL fcn1 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                               &     n_location, varp)

                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,213) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 461
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 461
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 461                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 361
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO

                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,701) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Genetic effect C11 (FS) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(*,800) ' Genetic effect C21 (FS) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    lambda1=1.0_dp/(1.0_dp-2.0_dp*avexb(3))
                    lower1=1.0_dp/(1.0_dp-2.0_dp*bootCI(3,1))
                    upper1=1.0_dp/(1.0_dp-2.0_dp*bootCI(3,2))
                    lambda2=1.0_dp/(1.0_dp-2.0_dp*avexb(4))
                    lower2=1.0_dp/(1.0_dp-2.0_dp*bootCI(4,1))
                    upper2=1.0_dp/(1.0_dp-2.0_dp*bootCI(4,2))
                    WRITE(*,800) ' Risk ratio lambda11 (FS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(*,800) ' Risk ratio lambda21 (FS) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'


                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'

                    WRITE(38,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C11 (FS) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(38,800) ' Genetic effect C21 (FS) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    WRITE(38,800) ' Risk ratio lambda11 (FS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(38,800) ' Risk ratio lambda21 (FS) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'


                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn1)
                 DEALLOCATE(reln1)
                 DEALLOCATE(familyn1tmp)
                 DEALLOCATE(familyn1)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(1) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' ================   Full-Sib subset analysis result   =================='
                 WRITE(*,'(/,A)') ' The number of full-sib pairs is under 15, skip the subset analysis for full sibs !'
                 WRITE(38,'(/,A,/)') ' ================   Full-Sib subset analysis result   =================='
                 WRITE(38,'(/,A)') ' The number of full-sib pairs is under 15, skip the subset analysis for full sibs !'
              END IF
           END IF
        

           ! 2. Subset - HS
           
           IF ( HS .EQ. 1 ) THEN
              IF (typerel(2) .GE. 15) THEN
                 NN = 4    
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn2(n_location,typerel(2)))
                 ALLOCATE(reln2(typerel(2)))
                 ALLOCATE(familyn2tmp(typerel(2)))
                 ALLOCATE(familyn2(typerel(2)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 2) THEN
                       j = j+1
                       IBDSn2(:,j) = IBDSn(:,i)
                       familyn2tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn2(1) = 1
                 DO i=2, typerel(2)
                    IF ( familyn2tmp(i) .NE. familyn2tmp(i-1) ) THEN
                       familyn2(i) = familyn2(i-1)+1
                    ELSE IF ( familyn2tmp(i) .EQ. familyn2tmp(i-1) ) THEN
                       familyn2(i) = familyn2(i-1)
                    END IF
                 END DO
                 x(1:2) = xini(1:2)
                 x(3:4) = xini(3)
                 arpno = typerel(2)
                 reln2 = 2
                 bound(1:2,1) = nlocation(1)             ! lower bound
                 bound(1:2,2) = nlocation(n_location)    ! upper bound
                 bound(3:NN,1) = -0.5_dp                 ! lower bound
                 bound(3:NN,2) = 0.5_dp                  ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ================   Half-Sib subset analysis result   =================='
                 WRITE(38,'(/,A,/)') ' ================   Half-Sib subset analysis result   =================='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
92                  CALL fcn2 (NN, x, fvec, arpno, IBDSn2, reln2, eps, IinvU, familyn2, subfamilyn2(typerel(2)), nlocation,  &
                         &     n_location, varp)
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,113) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 83
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C12 (HS) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(*,800) ' Genetic effect C22 (HS) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          lambda1=(1.0_dp+2.0_dp*x(3))/(1.0_dp-2.0_dp*x(3))
                          sel1=((2.0_dp/(1.0_dp-2.0_dp*x(3))+2.0_dp*(1.0_dp+2.0_dp*x(3))/  &
                               &   (1.0_dp-2.0_dp*x(3))**2)**2*varp(3,3))**0.5
                          lambda2=(1.0_dp+2.0_dp*x(4))/(1.0_dp-2.0_dp*x(4))
                          sel2=((2.0_dp/(1.0_dp-2.0_dp*x(4))+2.0_dp*(1.0_dp+2.0_dp*x(4))/  &
                               &   (1.0_dp-2.0_dp*x(4))**2)**2*varp(4,4))**0.5
                          WRITE(*,800) ' Risk ratio lambda12 (HS) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(*,800) ' Risk ratio lambda22 (HS) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 

                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,'(4A)')   '             tau1      ', '    tau2    ', '    C12   ', '     C22   '
                          WRITE(*,313) '   tau1 ', varp(:,1)
                          WRITE(*,313) '   tau2 ', varp(:,2)
                          WRITE(*,313) '    C12 ', varp(:,3)
                          WRITE(*,313) '    C22 ', varp(:,4)



                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C12 (HS) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(38,800) ' Genetic effect C22 (HS) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          WRITE(38,800) ' Risk ratio lambda12 (HS) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(38,800) ' Risk ratio lambda22 (HS) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 

                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,'(4A)')   '             tau1      ', '    tau2    ', '    C12   ', '     C22   '
                          WRITE(38,313) '   tau1 ', varp(:,1)
                          WRITE(38,313) '   tau2 ', varp(:,2)
                          WRITE(38,313) '    C12 ', varp(:,3)
                          WRITE(38,313) '    C22 ', varp(:,4)
             
                            
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No two disease genes or too poor initial values !'
                          WRITE(38,'(A)') ' No two disease genes or too poor initial values !'
                          GO TO 83
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 83
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No two disease genes or too poor initial values !'
                             WRITE(38,'(/,A)') ' No two disease genes or too poor initial values !'
                             GO TO 83                         
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 92
                    END IF
                 END DO   ! END Fisher's scoring METHOD
83               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn2(typerel(2))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
462                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn2(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn2(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn2(:,j)
                                relb(k)=reln2(j)
                                familyb(k)=familyn2(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1:2) = xini(1:2)
                       x(3:4) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
362                       CALL fcn2 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                         &     n_location, varp)
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,213) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 462
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 462
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 462                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 362
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO

                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,701) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Genetic effect C12 (HS) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(*,800) ' Genetic effect C22 (HS) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    j=3
                    lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                    lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                    upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                    j=4
                    lambda2=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                    lower2=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                    upper2=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                    WRITE(*,800) ' Risk ratio lambda12 (HS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(*,800) ' Risk ratio lambda22 (HS) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'


                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'

                    WRITE(38,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C12 (HS) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(38,800) ' Genetic effect C22 (HS) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    WRITE(38,800) ' Risk ratio lambda12 (HS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(38,800) ' Risk ratio lambda22 (HS) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'


                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn2)
                 DEALLOCATE(reln2)
                 DEALLOCATE(familyn2tmp)
                 DEALLOCATE(familyn2)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(2) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' ================   Half-Sib subset analysis result   =================='
                 WRITE(*,'(/,A)') ' The number of half-sib pairs is under 15, skip the subset analysis for half sibs !'
                 WRITE(38,'(/,A,/)') ' ================   Half-Sib subset analysis result   =================='
                 WRITE(38,'(/,A)') ' The number of half-sib pairs is under 15, skip the subset analysis for half sibs !'
              END IF
           END IF
           
        
           ! 3. Subset - FC
           IF ( FC .EQ. 1 ) THEN
              IF (typerel(3) .GE. 15) THEN
                 NN = 4    
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn3(n_location,typerel(3)))
                 ALLOCATE(reln3(typerel(3)))
                 ALLOCATE(familyn3tmp(typerel(3)))
                 ALLOCATE(familyn3(typerel(3)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 3) THEN
                       j = j+1
                       IBDSn3(:,j) = IBDSn(:,i)
                       familyn3tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn3(1) = 1
                 DO i=2, typerel(3)
                    IF ( familyn3tmp(i) .NE. familyn3tmp(i-1) ) THEN
                       familyn3(i) = familyn3(i-1)+1
                    ELSE IF ( familyn3tmp(i) .EQ. familyn3tmp(i-1) ) THEN
                       familyn3(i) = familyn3(i-1)
                    END IF
                 END DO
                 x(1:2) = xini(1:2)
                 x(3:4) = xini(3)
                 arpno = typerel(3)
                 reln3 = 3
                 bound(1:2,1) = nlocation(1)             ! lower bound
                 bound(1:2,2) = nlocation(n_location)    ! upper bound
                 bound(3:NN,1) = -0.25_dp                ! lower bound
                 bound(3:NN,2) = 0.75_dp                 ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ================   First-Cousin subset analysis result   =================='
                 WRITE(38,'(/,A,/)') ' ================   First-Cousin subset analysis result   =================='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO      ! START Fisher's scoring METHOD
                    iter=0
93                  CALL fcn3 (NN, x, fvec, arpno, IBDSn3, reln3, eps, IinvU, familyn3, subfamilyn3(typerel(3)), nlocation, &
                         &     n_location, varp)
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,113) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                WRITE(38,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 84
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'

                          WRITE(*,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C13 (FC) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(*,800) ' Genetic effect C23 (FC) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          lambda1=(3.0_dp+12.0_dp*x(3))/(3.0_dp-4.0_dp*x(3))
                          sel1=((12.0_dp/(3.0_dp-4.0_dp*x(3))+4.0_dp*(3.0_dp+12.0_dp*x(3))/  &
                               &   (3.0_dp-4.0_dp*x(3))**2)**2*varp(3,3))**0.5
                          lambda2=(3.0_dp+12.0_dp*x(4))/(3.0_dp-4.0_dp*x(4))
                          sel2=((12.0_dp/(3.0_dp-4.0_dp*x(4))+4.0_dp*(3.0_dp+12.0_dp*x(4))/  &
                               &   (3.0_dp-4.0_dp*x(4))**2)**2*varp(4,4))**0.5
                          WRITE(*,800) ' Risk ratio lambda13 (FC) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(*,800) ' Risk ratio lambda23 (FC) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 

                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,'(4A)')   '             tau1      ', '    tau2    ', '    C13   ', '     C23   '
                          WRITE(*,313) '   tau1 ', varp(:,1)
                          WRITE(*,313) '   tau2 ', varp(:,2)
                          WRITE(*,313) '    C13 ', varp(:,3)
                          WRITE(*,313) '    C23 ', varp(:,4)


                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'

                          WRITE(38,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C13 (FC) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(38,800) ' Genetic effect C23 (FC) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          WRITE(38,800) ' Risk ratio lambda13 (FC) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(38,800) ' Risk ratio lambda23 (FC) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 

                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,'(4A)')   '             tau1      ', '    tau2    ', '    C13   ', '     C23   '
                          WRITE(38,313) '   tau1 ', varp(:,1)
                          WRITE(38,313) '   tau2 ', varp(:,2)
                          WRITE(38,313) '    C13 ', varp(:,3)
                          WRITE(38,313) '    C23 ', varp(:,4)
          
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No two disease genes or too poor initial values !'
                          WRITE(38,'(A)') ' No two disease genes or too poor initial values !'
                          GO TO 84
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 84
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No two disease genes or too poor initial values !'
                             WRITE(38,'(/,A)') ' No two disease genes or too poor initial values !'
                             GO TO 84                          
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 93
                    END IF
                 END DO   ! END Fisher's scoring METHOD
84               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn3(typerel(3))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
463                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn3(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn3(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn3(:,j)
                                relb(k)=reln3(j)
                                familyb(k)=familyn3(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1:2) = xini(1:2)
                       x(3:4) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
363                       CALL fcn3 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                         &     n_location, varp)
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,213) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 463
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 463
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 463                        
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 363
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO


                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Genetic effect C13 (FC) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(*,800) ' Genetic effect C23 (FC) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    j=3
                    lambda1=(3.0_dp+12.0_dp*avexb(j))/(3.0_dp-4.0_dp*avexb(j))
                    lower1=(3.0_dp+12.0_dp*bootCI(j,1))/(3.0_dp-4.0_dp*bootCI(j,1))
                    upper1=(3.0_dp+12.0_dp*bootCI(j,2))/(3.0_dp-4.0_dp*bootCI(j,2))
                    j=4
                    lambda2=(3.0_dp+12.0_dp*avexb(j))/(3.0_dp-4.0_dp*avexb(j))
                    lower2=(3.0_dp+12.0_dp*bootCI(j,1))/(3.0_dp-4.0_dp*bootCI(j,1))
                    upper2=(3.0_dp+12.0_dp*bootCI(j,2))/(3.0_dp-4.0_dp*bootCI(j,2))
                    WRITE(*,800) ' Risk ratio lambda13 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(*,800) ' Risk ratio lambda23 (FC) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'


                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'

                    WRITE(38,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,701) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C13 (FC) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(38,800) ' Genetic effect C23 (FC) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    WRITE(38,800) ' Risk ratio lambda13 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(38,800) ' Risk ratio lambda23 (FC) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'


                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn3)
                 DEALLOCATE(reln3)
                 DEALLOCATE(familyn3tmp)
                 DEALLOCATE(familyn3)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(3) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' ================   First-Cousin subset analysis result   =================='
                 WRITE(*,'(/,A)') ' The number of first-cousin pairs is under 15, skip the subset analysis for first cousins !'
                 WRITE(38,'(/,A,/)') ' ================   First-Cousin subset analysis result   =================='
                 WRITE(38,'(/,A)') ' The number of first-cousin pairs is under 15, skip the subset analysis for first cousins !'
              END IF
           END IF
           
           
           ! 4. Subset - GP

           IF ( GP .EQ. 1 ) THEN
              IF (typerel(4) .GE. 15) THEN
                 NN = 4    
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn4(n_location,typerel(4)))
                 ALLOCATE(reln4(typerel(4)))
                 ALLOCATE(familyn4tmp(typerel(4)))
                 ALLOCATE(familyn4(typerel(4)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 4) THEN
                       j = j+1
                       IBDSn4(:,j) = IBDSn(:,i)
                       familyn4tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn4(1) = 1
                 DO i=2, typerel(4)
                    IF ( familyn4tmp(i) .NE. familyn4tmp(i-1) ) THEN
                       familyn4(i) = familyn4(i-1)+1
                    ELSE IF ( familyn4tmp(i) .EQ. familyn4tmp(i-1) ) THEN
                       familyn4(i) = familyn4(i-1)
                    END IF
                 END DO
                 x(1:2) = xini(1:2)
                 x(3:4) = xini(3)
                 arpno = typerel(4)
                 reln4 = 4
                 bound(1:2,1) = nlocation(1)             ! lower bound
                 bound(1:2,2) = nlocation(n_location)    ! upper bound
                 bound(3:NN,1) = -0.5_dp                 ! lower bound
                 bound(3:NN,2) = 0.5_dp                  ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ===========   Grandparent-Grandchild subset analysis result   ==========='
                 WRITE(38,'(/,A,/)') ' ===========   Grandparent-Grandchild subset analysis result   ==========='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
94                  CALL fcn4 (NN, x, fvec, arpno, IBDSn4, reln4, eps, IinvU, familyn4, subfamilyn4(typerel(4)), nlocation,  &
                         &     n_location, varp)
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,113) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                WRITE(38,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 85
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'

                          WRITE(*,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C14 (GP) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(*,800) ' Genetic effect C24 (GP) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          lambda1=(1.0_dp+2.0_dp*x(3))/(1.0_dp-2.0_dp*x(3))
                          sel1=((2.0_dp/(1.0_dp-2.0_dp*x(3))+2.0_dp*(1.0_dp+2.0_dp*x(3))/  &
                               &   (1.0_dp-2.0_dp*x(3))**2)**2*varp(3,3))**0.5
                          lambda2=(1.0_dp+2.0_dp*x(4))/(1.0_dp-2.0_dp*x(4))
                          sel2=((2.0_dp/(1.0_dp-2.0_dp*x(4))+2.0_dp*(1.0_dp+2.0_dp*x(4))/  &
                               &   (1.0_dp-2.0_dp*x(4))**2)**2*varp(4,4))**0.5
                          WRITE(*,800) ' Risk ratio lambda14 (GP) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(*,800) ' Risk ratio lambda24 (GP) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 

                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,'(4A)')   '             tau1      ', '    tau2    ', '    C14   ', '     C24   '
                          WRITE(*,313) '   tau1 ', varp(:,1)
                          WRITE(*,313) '   tau2 ', varp(:,2)
                          WRITE(*,313) '    C14 ', varp(:,3)
                          WRITE(*,313) '    C24 ', varp(:,4)    


                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C14 (GP) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(38,800) ' Genetic effect C24 (GP) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          WRITE(38,800) ' Risk ratio lambda14 (GP) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(38,800) ' Risk ratio lambda24 (GP) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,'(4A)')   '             tau1      ', '    tau2    ', '    C14   ', '     C24   '
                          WRITE(38,313) '   tau1 ', varp(:,1)
                          WRITE(38,313) '   tau2 ', varp(:,2)
                          WRITE(38,313) '    C14 ', varp(:,3)
                          WRITE(38,313) '    C24 ', varp(:,4)    

                              
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No two disease genes or too poor initial values !'
                          WRITE(38,'(A)') ' No two disease genes or too poor initial values !'
                          GO TO 85
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 85
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No two disease genes or too poor initial values !'
                             WRITE(38,'(/,A)') ' No two disease genes or too poor initial values !'
                             GO TO 85                         
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 94
                    END IF
                 END DO   ! END Fisher's scoring METHOD
85               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn4(typerel(4))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
464                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn4(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn4(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn4(:,j)
                                relb(k)=reln4(j)
                                familyb(k)=familyn4(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1:2) = xini(1:2)
                       x(3:4) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
364                       CALL fcn4 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                         &     n_location, varp)
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,213) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 464
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 464
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 464                        
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 364
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO


                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Genetic effect C14 (GP) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(*,800) ' Genetic effect C24 (GP) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    j=3
                    lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                    lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                    upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                    j=4
                    lambda2=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                    lower2=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                    upper2=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                    WRITE(*,800) ' Risk ratio lambda14 (GP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(*,800) ' Risk ratio lambda24 (GP) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'



                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'
                    WRITE(38,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,701) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C14 (GP) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(38,800) ' Genetic effect C24 (GP) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    WRITE(38,800) ' Risk ratio lambda14 (GP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(38,800) ' Risk ratio lambda24 (GP) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'


                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn4)
                 DEALLOCATE(reln4)
                 DEALLOCATE(familyn4tmp)
                 DEALLOCATE(familyn4)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(4) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' =========   Grandparent-Grandchild subset analysis result   =========='
                 WRITE(*,'(/,A)') ' The number of grandparent-grandchild pairs is under 15, skip the subset analysis for GP !'
                 WRITE(38,'(/,A,/)') ' =========   Grandparent-Grandchild subset analysis result   =========='
                 WRITE(38,'(/,A)') ' The number of grandparent-grandchild pairs is under 15, skip the subset analysis for GP !'
              END IF
           END IF
           

           ! 5. Subset - AP
           
           IF ( AP .EQ. 1 ) THEN
              IF (typerel(5) .GE. 15) THEN
                 NN = 4    
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(IBDSn5(n_location,typerel(5)))
                 ALLOCATE(reln5(typerel(5)))
                 ALLOCATE(familyn5tmp(typerel(5)))
                 ALLOCATE(familyn5(typerel(5)))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 j = 0
                 DO i=1, SUM(typereln)
                    IF ( reln(i) .EQ. 5) THEN
                       j = j+1
                       IBDSn5(:,j) = IBDSn(:,i)
                       familyn5tmp(j) = familyn(i)
                    END IF
                 END DO
                 familyn5(1) = 1
                 DO i=2, typerel(5)
                    IF ( familyn5tmp(i) .NE. familyn5tmp(i-1) ) THEN
                       familyn5(i) = familyn5(i-1)+1
                    ELSE IF ( familyn5tmp(i) .EQ. familyn5tmp(i-1) ) THEN
                       familyn5(i) = familyn5(i-1)
                    END IF
                 END DO
                 x(1:2) = xini(1:2)
                 x(3:4) = xini(3)
                 arpno = typerel(5)
                 reln5 = 5
                 bound(1:2,1) = nlocation(1)             ! lower bound
                 bound(1:2,2) = nlocation(n_location)    ! upper bound
                 bound(3:NN,1) = -0.5_dp                 ! lower bound
                 bound(3:NN,2) = 0.5_dp                  ! upper bound
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp
                 WRITE(*,'(/,A,/)') ' ================   Avuncular-Pair subset analysis result   =================='
                 WRITE(38,'(/,A,/)') ' ================   Avuncular-Pair subset analysis result   =================='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
95                  CALL fcn5 (NN, x, fvec, arpno, IBDSn5, reln5, eps, IinvU, familyn5, subfamilyn5(typerel(5)), nlocation,  &
                         &     n_location, varp)
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    WRITE(38,113) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                WRITE(38,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 86
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'

                          WRITE(*,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Genetic effect C15 (AP) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(*,800) ' Genetic effect C25 (AP) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          lambda1=(1.0_dp+2.0_dp*x(3))/(1.0_dp-2.0_dp*x(3))
                          sel1=((2.0_dp/(1.0_dp-2.0_dp*x(3))+2.0_dp*(1.0_dp+2.0_dp*x(3))/  &
                               &   (1.0_dp-2.0_dp*x(3))**2)**2*varp(3,3))**0.5
                          lambda2=(1.0_dp+2.0_dp*x(4))/(1.0_dp-2.0_dp*x(4))
                          sel2=((2.0_dp/(1.0_dp-2.0_dp*x(4))+2.0_dp*(1.0_dp+2.0_dp*x(4))/  &
                               &   (1.0_dp-2.0_dp*x(4))**2)**2*varp(4,4))**0.5
                          WRITE(*,800) ' Risk ratio lambda15 (AP) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(*,800) ' Risk ratio lambda25 (AP) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 

                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,'(4A)')   '             tau1      ', '    tau2    ', '    C15   ', '     C25   '
                          WRITE(*,313) '   tau1 ', varp(:,1)
                          WRITE(*,313) '   tau2 ', varp(:,2)
                          WRITE(*,313) '    C15 ', varp(:,3)
                          WRITE(*,313) '    C25 ', varp(:,4)       


                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'

                          WRITE(38,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Genetic effect C15 (AP) =', x(3),  &
                               &  '(', x(3)-1.96_dp*se(3), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(38,800) ' Genetic effect C25 (AP) =', x(4),  &
                               &  '(', x(4)-1.96_dp*se(4), '-', x(4)+1.96_dp*se(4), ')'
                          WRITE(38,800) ' Risk ratio lambda15 (AP) =', lambda1, '(',  &
                               &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                          WRITE(38,800) ' Risk ratio lambda25 (AP) =', lambda2, '(',  &
                               &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,'(4A)')   '             tau1      ', '    tau2    ', '    C15   ', '     C25   '
                          WRITE(38,313) '   tau1 ', varp(:,1)
                          WRITE(38,313) '   tau2 ', varp(:,2)
                          WRITE(38,313) '    C15 ', varp(:,3)
                          WRITE(38,313) '    C25 ', varp(:,4)       
            
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No two disease genes or too poor initial values !'
                          WRITE(38,'(A)') ' No two disease genes or too poor initial values !'
                          GO TO 86
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 86
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No two disease genes or too poor initial values !'
                             WRITE(38,'(/,A)') ' No two disease genes or too poor initial values !'
                             GO TO 86                          
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 95
                    END IF
                 END DO   ! END Fisher's scoring METHOD
86               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=subfamilyn5(typerel(5))
                    kind=1
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
465                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn5(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO          
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familyn5(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSn5(:,j)
                                relb(k)=reln5(j)
                                familyb(k)=familyn5(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1:2) = xini(1:2)
                       x(3:4) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
365                       CALL fcn5 (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n, nlocation, &
                         &     n_location, varp)
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          WRITE(38,213) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 465
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 465
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 465                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 365
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO

                    ! Sorting 

                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO

                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO

                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'

                    WRITE(*,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,701) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Genetic effect C15 (AP) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(*,800) ' Genetic effect C25 (AP) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    j=3
                    lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                    lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                    upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                    j=4
                    lambda2=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                    lower2=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                    upper2=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                    WRITE(*,800) ' Risk ratio lambda15 (AP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(*,800) ' Risk ratio lambda25 (AP) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'


                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'
                    WRITE(38,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Genetic effect C15 (AP) =', avexb(3), '(',bootCI(3,1), '-', bootCI(3,2), ')'  
                    WRITE(38,800) ' Genetic effect C25 (AP) =', avexb(4), '(',bootCI(4,1), '-', bootCI(4,2), ')'                       
                    WRITE(38,800) ' Risk ratio lambda15 (AP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    WRITE(38,800) ' Risk ratio lambda25 (AP) =', lambda2, '(', MAX(0.0_dp,lower2), '-', upper2, ')'



                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(IBDSn5)
                 DEALLOCATE(reln5)
                 DEALLOCATE(familyn5tmp)
                 DEALLOCATE(familyn5)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)     
              ELSE IF (typerel(5) .LT. 15) THEN
                 WRITE(*,'(/,A,/)') ' ================   Avuncular-Pair subset analysis result   =================='
                 WRITE(*,'(/,A)') ' The number of avuncular pairs is under 15, skip the subset analysis for avuncular pairs !'
                 WRITE(38,'(/,A,/)') ' ================   Avuncular-Pair subset analysis result   =================='
                 WRITE(38,'(/,A)') ' The number of avuncular pairs is under 15, skip the subset analysis for avuncular pairs !'
              END IF
           END IF
        END IF

        
        ! 6. Unconstrained-Model Approach 

        IF ( (METHOD .EQ. 'A') .OR. (METHOD .EQ. 'B') ) THEN
           DEALLOCATE(typeno)
           IF (SUM(typereln) .GE. 15) THEN
              cou = 0
              NN = 2
              k = 0
              IF ( (typerel(1) .GE. 15) .AND. (FS .EQ. 1) ) THEN
                 cou = cou+typerel(1)
                 FS = 1
                 NN = NN+2
                 k = k+1
              ELSE
                 FS = 0
              END IF
              IF ( (typerel(2) .GE. 15) .AND. (HS .EQ. 1) ) THEN
                 cou = cou+typerel(2)
                 HS = 1
                 NN = NN+2
                 k = k+1
              ELSE
                 HS = 0
              END IF
              IF ( (typerel(3) .GE. 15) .AND. (FC .EQ. 1) ) THEN
                 cou = cou+typerel(3)
                 FC = 1
                 NN = NN+2
                 k = k+1
              ELSE
                 FC = 0
              END IF
              IF ( (typerel(4) .GE. 15) .AND. (GP .EQ. 1) ) THEN
                 cou = cou+typerel(4)
                 GP = 1
                 NN = NN+2
                 k = k+1
              ELSE
                 GP = 0
              END IF
              IF ( (typerel(5) .GE. 15) .AND. (AP .EQ. 1) ) THEN
                 cou = cou+typerel(5)
                 AP = 1
                 NN = NN+2
                 k = k+1
              ELSE
                 AP = 0 
              END IF

              arpno = cou
              
              ALLOCATE(typeno(k))
              j=0
              IF ( FS .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=1
              END IF
              IF ( HS .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=2
              END IF
              IF ( FC .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=3
              END IF
              IF ( GP .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=4
              END IF
              IF ( AP .EQ. 1 ) THEN
                 j=j+1
                 typeno(j)=5
              END IF
              

              ALLOCATE(IBDSnn(n_location,cou))
              ALLOCATE(relnn(cou))
              ALLOCATE(familynntmp(cou))
              ALLOCATE(familynn(cou))

              j = 0
              DO i=1, SUM(typereln)
                 DO k=1, SIZE(typeno)
                    IF ( reln(i) .EQ. typeno(k) ) THEN
                       j = j+1
                       relnn(j) = reln(i)
                       IBDSnn(:,j) = IBDSn(:,i)
                       familynntmp(j) = familyn(i)
                    END IF
                 END DO
              END DO
              familynn(1) = 1
              DO i=2, cou
                 IF ( familynntmp(i) .NE. familynntmp(i-1) ) THEN
                    familynn(i) = familynn(i-1)+1
                 ELSE IF ( familynntmp(i) .EQ. familynntmp(i-1) ) THEN
                    familynn(i) = familynn(i-1) 
                 END IF
              END DO

              IF ( (constrained .EQ. 'U') .OR. (constrained .EQ. 'B') ) THEN

                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))
                 
                 x(1:2) = xini(1:2)
                 x(3:NN) = xini(3)
                 bound(1:2,1) = nlocation(1)             ! lower bound
                 bound(1:2,2) = nlocation(n_location)    ! upper bound
                 j=0
                 IF ( FS .EQ. 1 ) THEN
                    j=j+1
                    bound(2*(j+1)-1:2*(j+1),1) = -1.0_dp                 ! lower bound
                    bound(2*(j+1)-1:2*(j+1),2) = 0.5_dp                  ! upper bound
                 END IF
                 IF ( HS .EQ. 1 ) THEN
                    j=j+1
                    bound(2*(j+1)-1:2*(j+1),1) = -0.5_dp                 ! lower bound
                    bound(2*(j+1)-1:2*(j+1),2) = 0.5_dp                  ! upper bound
                 END IF
                 IF ( FC .EQ. 1 ) THEN
                    j=j+1
                    bound(2*(j+1)-1:2*(j+1),1) = -0.25_dp                ! lower bound
                    bound(2*(j+1)-1:2*(j+1),2) = 0.75_dp                 ! upper bound
                 END IF
                 IF ( GP .EQ. 1 ) THEN
                    j=j+1
                    bound(2*(j+1)-1:2*(j+1),1) = -0.5_dp                 ! lower bound
                    bound(2*(j+1)-1:2*(j+1),2) = 0.5_dp                  ! upper bound
                 END IF
                 IF ( AP .EQ. 1 ) THEN
                    j=j+1
                    bound(2*(j+1)-1:2*(j+1),1) = -0.5_dp                 ! lower bound
                    bound(2*(j+1)-1:2*(j+1),2) = 0.5_dp                  ! upper bound
                 END IF
                 x_lower = -2.0_dp
                 x_upper = 5.0_dp


                 WRITE(*,'(/,A,/)') ' ===========   Unconstrained-Model Approach analysis result   ============='
                 WRITE(38,'(/,A,/)') ' ===========   Unconstrained-Model Approach analysis result   ============='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp
                 DO       ! START Fisher's scoring METHOD
                    iter=0
96                  CALL fcn (NN, x, fvec, arpno, IBDSnn, relnn, eps, IinvU, familynn, familynn(arpno), nlocation, n_location,  &
                         &    varp, typeno, SIZE(typeno) )
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO

                    SELECT CASE (SIZE(typeno))
                    CASE (1)
                       WRITE(38,113) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    CASE (2)
                       WRITE(38,115) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    CASE (3)
                       WRITE(38,116) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    CASE (4)
                       WRITE(38,117) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    CASE (5)
                       WRITE(38,118) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    END SELECT

                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                WRITE(38,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 87
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)

!!!!!
!                          WRITE(62,'(8F12.8)') x
!                          WRITE(63,'(8F12.8)') se
!                          WRITE(64,'(6F12.8)') varp(1,1), varp(3,3), varp(1,3), varp(2,2), varp(4,4), varp(2,4)
                          
                          WRITE(*,'(A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'

                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'

                          j=2
                          IF ( FS .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C11 (FS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C11 (FS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             j=j+1
                             WRITE(*,800) ' Genetic effect C21 (FS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C21 (FS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          IF ( HS .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C12 (HS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C12 (HS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             j=j+1
                             WRITE(*,800) ' Genetic effect C22 (HS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C22 (HS) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          IF ( FC .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C13 (FC) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C13 (FC) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             j=j+1
                             WRITE(*,800) ' Genetic effect C23 (FC) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C23 (FC) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          IF ( GP .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C14 (GP) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C14 (GP) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             j=j+1
                             WRITE(*,800) ' Genetic effect C24 (GP) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C24 (GP) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          IF ( AP .EQ. 1 ) THEN
                             j=j+1
                             WRITE(*,800) ' Genetic effect C15 (AP) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C15 (AP) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             j=j+1
                             WRITE(*,800) ' Genetic effect C25 (AP) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                             WRITE(38,800) ' Genetic effect C25 (AP) =', x(j),  &
                                  &  '(', x(j)-1.96_dp*se(j), '-', x(j)+1.96_dp*se(j), ')'
                          END IF
                          
                          j=2
                          IF ( FS .EQ. 1 ) THEN
                             j=j+1
                             lambda1=1.0_dp/(1.0_dp-2.0_dp*x(j))
                             sel1=((2.0_dp/(1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda11 (FS) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             WRITE(38,800) ' Risk ratio lambda11 (FS) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             j=j+1
                             lambda2=1.0_dp/(1.0_dp-2.0_dp*x(j))
                             sel2=((2.0_dp/(1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda21 (FS) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                             WRITE(38,800) ' Risk ratio lambda21 (FS) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                          END IF
                          IF ( HS .EQ. 1 ) THEN
                             j=j+1
                             lambda1=(1.0_dp+2.0_dp*x(j))/(1.0_dp-2.0_dp*x(j))
                             sel1=((2.0_dp/(1.0_dp-2.0_dp*x(j))+2.0_dp*(1.0_dp+2.0_dp*x(j))/  &
                                  &   (1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda12 (HS) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             WRITE(38,800) ' Risk ratio lambda12 (HS) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             j=j+1
                             lambda2=(1.0_dp+2.0_dp*x(j))/(1.0_dp-2.0_dp*x(j))
                             sel2=((2.0_dp/(1.0_dp-2.0_dp*x(j))+2.0_dp*(1.0_dp+2.0_dp*x(j))/  &
                                  &   (1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda22 (HS) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                             WRITE(38,800) ' Risk ratio lambda22 (HS) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                          END IF
                          IF ( FC .EQ. 1 ) THEN
                             j=j+1
                             lambda1=(3.0_dp+12.0_dp*x(j))/(3.0_dp-4.0_dp*x(j))
                             sel1=((12.0_dp/(3.0_dp-4.0_dp*x(j))+4.0_dp*(3.0_dp+12.0_dp*x(j))/  &
                                  &   (3.0_dp-4.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda13 (FC) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             WRITE(38,800) ' Risk ratio lambda13 (FC) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             j=j+1
                             lambda2=(3.0_dp+12.0_dp*x(j))/(3.0_dp-4.0_dp*x(j))
                             sel2=((12.0_dp/(3.0_dp-4.0_dp*x(j))+4.0_dp*(3.0_dp+12.0_dp*x(j))/  &
                                  &   (3.0_dp-4.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda23 (FC) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                             WRITE(38,800) ' Risk ratio lambda23 (FC) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                          END IF
                          IF ( GP .EQ. 1 ) THEN
                             j=j+1
                             lambda1=(1.0_dp+2.0_dp*x(j))/(1.0_dp-2.0_dp*x(j))
                             sel1=((2.0_dp/(1.0_dp-2.0_dp*x(j))+2.0_dp*(1.0_dp+2.0_dp*x(j))/  &
                                  &   (1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda14 (GP) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             WRITE(38,800) ' Risk ratio lambda14 (GP) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             j=j+1
                             lambda2=(1.0_dp+2.0_dp*x(j))/(1.0_dp-2.0_dp*x(j))
                             sel2=((2.0_dp/(1.0_dp-2.0_dp*x(j))+2.0_dp*(1.0_dp+2.0_dp*x(j))/  &
                                  &   (1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda24 (GP) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                             WRITE(38,800) ' Risk ratio lambda24 (GP) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                          END IF
                          IF ( AP .EQ. 1 ) THEN
                             j=j+1
                             lambda1=(1.0_dp+2.0_dp*x(j))/(1.0_dp-2.0_dp*x(j))
                             sel1=((2.0_dp/(1.0_dp-2.0_dp*x(j))+2.0_dp*(1.0_dp+2.0_dp*x(j))/  &
                                  &   (1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda15 (AP) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             WRITE(38,800) ' Risk ratio lambda15 (AP) =', lambda1, '(',  &
                                  &   MAX(0.0_dp,lambda1-1.96_dp*sel1), '-', lambda1+1.96_dp*sel1, ')' 
                             j=j+1
                             lambda2=(1.0_dp+2.0_dp*x(j))/(1.0_dp-2.0_dp*x(j))
                             sel2=((2.0_dp/(1.0_dp-2.0_dp*x(j))+2.0_dp*(1.0_dp+2.0_dp*x(j))/  &
                                  &   (1.0_dp-2.0_dp*x(j))**2)**2*varp(j,j))**0.5
                             WRITE(*,800) ' Risk ratio lambda25 (AP) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                             WRITE(38,800) ' Risk ratio lambda25 (AP) =', lambda2, '(',  &
                                  &   MAX(0.0_dp,lambda2-1.96_dp*sel2), '-', lambda2+1.96_dp*sel2, ')' 
                          END IF
                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          SELECT CASE (SIZE(typeno))
                          CASE (1)
                             WRITE(*,'(2A,2(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1)
                             WRITE(*,313) '  tau1  ', varp(:,1)
                             WRITE(*,313) '  tau2  ', varp(:,2)
                             WRITE(*,'(A,I1,2X,4F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(*,'(A,I1,2X,4F12.8)') '   C2', typeno(1), varp(:,4)

                             WRITE(38,'(2A,2(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1)
                             WRITE(38,313) '  tau1  ', varp(:,1)
                             WRITE(38,313) '  tau2  ', varp(:,2)
                             WRITE(38,'(A,I1,2X,4F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(38,'(A,I1,2X,4F12.8)') '   C2', typeno(1), varp(:,4)

                          CASE (2)
                             WRITE(*,'(2A,4(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1), '     C1', typeno(2), '     C2', typeno(2)
                             WRITE(*,315) '  tau1  ', varp(:,1)
                             WRITE(*,315) '  tau2  ', varp(:,2)
                             WRITE(*,'(A,I1,2X,6F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(*,'(A,I1,2X,6F12.8)') '   C2', typeno(1), varp(:,4)
                             WRITE(*,'(A,I1,2X,6F12.8)') '   C1', typeno(2), varp(:,5)
                             WRITE(*,'(A,I1,2X,6F12.8)') '   C2', typeno(2), varp(:,6)

                             WRITE(38,'(2A,4(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1), '     C1', typeno(2), '     C2', typeno(2)
                             WRITE(38,315) '  tau1  ', varp(:,1)
                             WRITE(38,315) '  tau2  ', varp(:,2)
                             WRITE(38,'(A,I1,2X,6F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(38,'(A,I1,2X,6F12.8)') '   C2', typeno(1), varp(:,4)
                             WRITE(38,'(A,I1,2X,6F12.8)') '   C1', typeno(2), varp(:,5)
                             WRITE(38,'(A,I1,2X,6F12.8)') '   C2', typeno(2), varp(:,6)
                          CASE (3)
                             WRITE(*,'(2A,6(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1), '      C1', typeno(2), '     C2', typeno(2)  &
                                  & , '   C1', typeno(3), '   C2', typeno(3)
                             WRITE(*,316) '  tau1  ', varp(:,1)
                             WRITE(*,316) '  tau2  ', varp(:,2)
                             WRITE(*,'(A,I1,2X,8F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(*,'(A,I1,2X,8F12.8)') '   C2', typeno(1), varp(:,4)
                             WRITE(*,'(A,I1,2X,8F12.8)') '   C1', typeno(2), varp(:,5)
                             WRITE(*,'(A,I1,2X,8F12.8)') '   C2', typeno(2), varp(:,6)
                             WRITE(*,'(A,I1,2X,8F12.8)') '   C1', typeno(3), varp(:,7)
                             WRITE(*,'(A,I1,2X,8F12.8)') '   C2', typeno(3), varp(:,8)

                             WRITE(38,'(2A,6(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1), '      C1', typeno(2), '     C2', typeno(2)  &
                                  & , '   C1', typeno(3), '   C2', typeno(3)
                             WRITE(38,316) '  tau1  ', varp(:,1)
                             WRITE(38,316) '  tau2  ', varp(:,2)
                             WRITE(38,'(A,I1,2X,8F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(38,'(A,I1,2X,8F12.8)') '   C2', typeno(1), varp(:,4)
                             WRITE(38,'(A,I1,2X,8F12.8)') '   C1', typeno(2), varp(:,5)
                             WRITE(38,'(A,I1,2X,8F12.8)') '   C2', typeno(2), varp(:,6)
                             WRITE(38,'(A,I1,2X,8F12.8)') '   C1', typeno(3), varp(:,7)
                             WRITE(38,'(A,I1,2X,8F12.8)') '   C2', typeno(3), varp(:,8)
                          CASE (4)
                             WRITE(*,'(2A,8(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1), '     C1', typeno(2), '     C2', typeno(2)  &
                                  & , '    C1', typeno(3), '    C2', typeno(3)  &
                                  & , '    C1', typeno(4), '    C2', typeno(4)
                             WRITE(*,317) '  tau1  ', varp(:,1)
                             WRITE(*,317) '  tau2  ', varp(:,2)
                             WRITE(*,'(A,I1,2X,10F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(*,'(A,I1,2X,10F12.8)') '   C2', typeno(1), varp(:,4)
                             WRITE(*,'(A,I1,2X,10F12.8)') '   C1', typeno(2), varp(:,5)
                             WRITE(*,'(A,I1,2X,10F12.8)') '   C2', typeno(2), varp(:,6)
                             WRITE(*,'(A,I1,2X,10F12.8)') '   C1', typeno(3), varp(:,7)
                             WRITE(*,'(A,I1,2X,10F12.8)') '   C2', typeno(3), varp(:,8)
                             WRITE(*,'(A,I1,2X,10F12.8)') '   C1', typeno(3), varp(:,9)
                             WRITE(*,'(A,I1,2X,10F12.8)') '   C2', typeno(3), varp(:,10)

                             WRITE(38,'(2A,8(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1), '     C1', typeno(2), '     C2', typeno(2)  &
                                  & , '    C1', typeno(3), '    C2', typeno(3)  &
                                  & , '    C1', typeno(4), '    C2', typeno(4)
                             WRITE(38,317) '  tau1  ', varp(:,1)
                             WRITE(38,317) '  tau2  ', varp(:,2)
                             WRITE(38,'(A,I1,2X,10F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(38,'(A,I1,2X,10F12.8)') '   C2', typeno(1), varp(:,4)
                             WRITE(38,'(A,I1,2X,10F12.8)') '   C1', typeno(2), varp(:,5)
                             WRITE(38,'(A,I1,2X,10F12.8)') '   C2', typeno(2), varp(:,6)
                             WRITE(38,'(A,I1,2X,10F12.8)') '   C1', typeno(3), varp(:,7)
                             WRITE(38,'(A,I1,2X,10F12.8)') '   C2', typeno(3), varp(:,8)
                             WRITE(38,'(A,I1,2X,10F12.8)') '   C1', typeno(3), varp(:,9)
                             WRITE(38,'(A,I1,2X,10F12.8)') '   C2', typeno(3), varp(:,10)
                          CASE (5)
                             WRITE(*,'(2A,10(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1), '     C1', typeno(2), '     C2', typeno(2)  &
                                  & , '   C1', typeno(3), '   C2', typeno(3)  &
                                  & , '   C1', typeno(4), '   C2', typeno(4)  &
                                  & , '   C1', typeno(5), '   C2', typeno(5)
                             WRITE(*,318) '  tau1  ', varp(:,1)
                             WRITE(*,318) '  tau2  ', varp(:,2)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C2', typeno(1), varp(:,4)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C1', typeno(2), varp(:,5)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C2', typeno(2), varp(:,6)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C1', typeno(3), varp(:,7)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C2', typeno(3), varp(:,8)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C1', typeno(3), varp(:,9)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C2', typeno(3), varp(:,10)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C1', typeno(3), varp(:,11)
                             WRITE(*,'(A,I1,2X,12F12.8)') '   C2', typeno(3), varp(:,12)

                             WRITE(38,'(2A,10(A,I1,4X))')   '            tau1      ', '    tau2    ', '    C1', typeno(1),  &
                                  &   '      C2', typeno(1), '     C1', typeno(2), '     C2', typeno(2)  &
                                  & , '   C1', typeno(3), '   C2', typeno(3)  &
                                  & , '   C1', typeno(4), '   C2', typeno(4)  &
                                  & , '   C1', typeno(5), '   C2', typeno(5)
                             WRITE(38,318) '  tau1  ', varp(:,1)
                             WRITE(38,318) '  tau2  ', varp(:,2)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C1', typeno(1), varp(:,3)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C2', typeno(1), varp(:,4)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C1', typeno(2), varp(:,5)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C2', typeno(2), varp(:,6)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C1', typeno(3), varp(:,7)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C2', typeno(3), varp(:,8)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C1', typeno(3), varp(:,9)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C2', typeno(3), varp(:,10)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C1', typeno(3), varp(:,11)
                             WRITE(38,'(A,I1,2X,12F12.8)') '   C2', typeno(3), varp(:,12)
                          END SELECT
                  
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No two disease genes or too poor initial values !'
                          WRITE(*,'(A)') ' Look into the constrained-model approach ... '
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(A)') ' No two disease genes or too poor initial values !'
                          WRITE(38,'(A)') ' Look into the constrained-model approach ... '
                          GO TO 87
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter1 ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter1, 'iterations !'
                          WRITE(*,'(/,A)') ' Look into the constrained-model approach ... '
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter1, 'iterations !'
                          WRITE(38,'(/,A)') ' Look into the constrained-model approach ... '
                          GO TO 87
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No two disease genes or too poor initial values !'
                             WRITE(38,'(/,A)') ' No two disease genes or too poor initial values !'
                             GO TO 87                          
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 96
                    END IF
                 END DO   ! END Fisher's scoring METHOD


              
87               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    n=familynn(arpno)
                    kind=SIZE(typeno)
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
466                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familynn(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familynn(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSnn(:,j)
                                relb(k)=relnn(j)
                                familyb(k)=familynn(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1:2) = xini(1:2)
                       x(3:NN) = xini(3)
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
366                       CALL fcn (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n,  & 
                               &  nlocation, n_location, varp, typeno, SIZE(typeno) )
                          
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          
                          SELECT CASE (kind)
                          CASE (1)
                             WRITE(38,213) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp,  &
                                  &  x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          CASE (2)
                             WRITE(38,215) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp,  &
                                  &  x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          CASE (3)
                             WRITE(38,216) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp,  &
                                  &  x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          CASE (4)
                             WRITE(38,217) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp,  &
                                  &  x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          CASE (5)
                             WRITE(38,218) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp,  &
                                  &  x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          END SELECT
                          
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                WRITE(67,'(8F12.8)') x
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 466
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 466
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 466                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 366
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO
                    
                    ! Sorting 
                    
                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO
                 
                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO

                 
                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'
                 
                    WRITE(*,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,701) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'

                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'
                 
                    WRITE(38,700) ' Location for tau  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'

!!!!!!
!                    WRITE(66,'(8F12.8)') avexb
!                    WRITE(68,'(4F12.8)') bootCI(1,1)*100.0_dp, bootCI(1,2)*100.0_dp, bootCI(2,1)*100.0_dp, bootCI(2,2)*100.0_dp
                    
                    j=2
                    IF ( FS .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C11 (FS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C11 (FS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       j=j+1
                       WRITE(*,800) ' Genetic effect C21 (FS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C21 (FS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                    IF ( HS .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C12 (HS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C12 (HS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       j=j+1
                       WRITE(*,800) ' Genetic effect C22 (HS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C22 (HS) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                    IF ( FC .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C13 (FC) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C13 (FC) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       j=j+1
                       WRITE(*,800) ' Genetic effect C23 (FC) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C23 (FC) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                    IF ( GP .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C14 (GP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C14 (GP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       j=j+1
                       WRITE(*,800) ' Genetic effect C24 (GP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C24 (GP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                    IF ( AP .EQ. 1 ) THEN
                       j=j+1
                       WRITE(*,800) ' Genetic effect C15 (AP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')'
                       WRITE(38,800) ' Genetic effect C15 (AP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       j=j+1
                       WRITE(*,800) ' Genetic effect C25 (AP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                       WRITE(38,800) ' Genetic effect C25 (AP) =', avexb(j), '(',bootCI(j,1), '-', bootCI(j,2), ')' 
                    END IF
                 
                    j=2
                    IF ( FS .EQ. 1 ) THEN
                       j=j+1
                       lambda1=1.0_dp/(1.0_dp-2.0_dp*avexb(j))
                       lower1=1.0_dp/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=1.0_dp/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda11 (FS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda11 (FS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       j=j+1
                       lambda1=1.0_dp/(1.0_dp-2.0_dp*avexb(j))
                       lower1=1.0_dp/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=1.0_dp/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda21 (FS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda21 (FS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    IF ( HS .EQ. 1 ) THEN
                       j=j+1
                       lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                       lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda12 (HS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda12 (HS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       j=j+1
                       lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                       lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda22 (HS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda22 (HS) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    IF ( FC .EQ. 1 ) THEN
                       j=j+1
                       lambda1=(3.0_dp+12.0_dp*avexb(j))/(3.0_dp-4.0_dp*avexb(j))
                       lower1=(3.0_dp+12.0_dp*bootCI(j,1))/(3.0_dp-4.0_dp*bootCI(j,1))
                       upper1=(3.0_dp+12.0_dp*bootCI(j,2))/(3.0_dp-4.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda13 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda13 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       j=j+1
                       lambda1=(3.0_dp+12.0_dp*avexb(j))/(3.0_dp-4.0_dp*avexb(j))
                       lower1=(3.0_dp+12.0_dp*bootCI(j,1))/(3.0_dp-4.0_dp*bootCI(j,1))
                       upper1=(3.0_dp+12.0_dp*bootCI(j,2))/(3.0_dp-4.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda23 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda23 (FC) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    IF ( GP .EQ. 1 ) THEN
                       j=j+1
                       lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                       lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda14 (GP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda14 (GP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       j=j+1
                       lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                       lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda24 (GP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda24 (GP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    IF ( AP .EQ. 1 ) THEN
                       j=j+1
                       lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                       lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda15 (AP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda15 (AP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       j=j+1
                       lambda1=(1.0_dp+2.0_dp*avexb(j))/(1.0_dp-2.0_dp*avexb(j))
                       lower1=(1.0_dp+2.0_dp*bootCI(j,1))/(1.0_dp-2.0_dp*bootCI(j,1))
                       upper1=(1.0_dp+2.0_dp*bootCI(j,2))/(1.0_dp-2.0_dp*bootCI(j,2))
                       WRITE(*,800) ' Risk ratio lambda25 (AP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                       WRITE(38,800) ' Risk ratio lambda25 (AP) =', lambda1, '(', MAX(0.0_dp,lower1), '-', upper1, ')'
                    END IF
                    
                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper) 

              END IF


              ! 7. Constrained-Model Approach 

              IF ( (constrained .EQ. 'C') .OR. (constrained .EQ. 'B') ) THEN

                 NN=4
                 ALLOCATE(x(NN))
                 ALLOCATE(fvec(NN))
                 ALLOCATE(IinvU(NN))
                 ALLOCATE(varp(NN,NN))
                 ALLOCATE(se(NN))
                 ALLOCATE(bound(NN,2))
                 ALLOCATE(x_lower(NN))
                 ALLOCATE(x_upper(NN))

               
                 x(1:2) = xini(1:2)
                 x(3:NN) = 1.0_dp/(1.0_dp-2.0_dp*xini(3))
                 bound(1:2,1) = nlocation(1)             ! lower bound
                 bound(1:2,2) = nlocation(n_location)    ! upper bound
                 bound(3:NN,1) = 0.0_dp                  ! lower bound
                 bound(3:NN,2) = 1000.0_dp               ! upper bound
                 x_lower = -20.0_dp
                 x_upper = 100.0_dp
                 WRITE(*,'(/,A)') ' =============   Constrained-Model Approach analysis result   ==============='
                 WRITE(38,'(/,A)') ' =============   Constrained-Model Approach analysis result   ==============='
                 oldx2 = 0.0_dp
                 oldx1 = 0.0_dp


                 DO       ! START Fisher's scoring METHOD
                    iter=0
97                  CALL fcnc (NN, x, fvec, arpno, IBDSnn, relnn, eps, IinvU, familynn, familynn(arpno), nlocation, n_location,  &
                         &    varp, typeno, SIZE(typeno) )
                    
                    sta=0.0_dp
                    DO i=1, NN
                       sta=sta+abs(fvec(i))
                    END DO
                    
                    WRITE(38,113) 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                    IF(sta .LT. tolimit) THEN
                       cou=0
                       DO i=1, NN
                          IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                             cou=cou+1
                          ELSE 
                             cou=cou
                          END IF
                       END DO
                       IF ( cou .EQ. NN ) THEN
                          !              point(1:NN,rr)=x(1:NN)
                          DO k=1, NN
                             IF ( (varp(k,k) .GT. 0.0_dp) .AND. (varp(k,k) .LT. 100.0_dp) ) THEN 
                                se(k)=varp(k,k)**0.5
                             ELSE
                                WRITE(*,'(/,A)') ' The robust variance cannot be evaluated !'
                                WRITE(38,'(/,A)') ' The robust variance cannot be evaluated !'
                                GO TO 88
                             END IF
                          END DO
                          !              rose(1:NN,rr)=se(1:NN)
!!!!!
!                          WRITE(72,'(4F12.8)') x
!                          WRITE(73,'(4F12.8)') se
!                          WRITE(74,'(6F12.8)') varp(1,1), varp(3,3), varp(1,3), varp(2,2), varp(4,4), varp(2,4)
                          
                          WRITE(*,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(*,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(*,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  & 
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,701) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(*,800) ' Common risk ratio lambda1 =', x(3),  &
                               &  '(', MAX(0.0_dp,x(3)-1.96_dp*se(3)), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(*,800) ' Common risk ratio lambda2 =', x(4),  &
                               &  '(', MAX(0.0_dp,x(4)-1.96_dp*se(4)), '-', x(4)+1.96_dp*se(4), ')'
                          
                          WRITE(*,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(*,'(4A)')   '                tau1   ', '   tau2    ', '   lambda1   ', '   lambda2   '
                          WRITE(*,313) '   tau1   ', varp(:,1)
                          WRITE(*,313) '   tau2   ', varp(:,2)
                          WRITE(*,313) '  lambda1 ', varp(:,3)
                          WRITE(*,313) '  lambda2 ', varp(:,4)




                          WRITE(38,'(/,A,I3,A)') ' Converged in ', iter, ' iterations.'  
                          WRITE(38,'(A)') ' Point estimates and 95% robust CI :'
                          WRITE(38,700) ' Location for tau1  =', x(1)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(1)*100.0_dp-1.96_dp*se(1)*100.0_dp), '-',  &
                               &       MIN(x(1)*100.0_dp+1.96_dp*se(1)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Location for tau2  =', x(2)*100.0_dp,  &
                               &  '(', MAX(0.0_dp,x(2)*100.0_dp-1.96_dp*se(2)*100.0_dp), '-',  &
                               &       MIN(x(2)*100.0_dp+1.96_dp*se(2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                          WRITE(38,800) ' Common risk ratio lambda1 =', x(3),  &
                               &  '(', MAX(0.0_dp,x(3)-1.96_dp*se(3)), '-', x(3)+1.96_dp*se(3), ')'
                          WRITE(38,800) ' Common risk ratio lambda2 =', x(4),  &
                               &  '(', MAX(0.0_dp,x(4)-1.96_dp*se(4)), '-', x(4)+1.96_dp*se(4), ')'
                          
                          WRITE(38,*) 'Robust Variance Estimate, here tau is in Morgans :'
                          WRITE(38,'(4A)')   '                tau1   ', '   tau2    ', '   lambda1   ', '   lambda2   '
                          WRITE(38,313) '   tau1   ', varp(:,1)
                          WRITE(38,313) '   tau2   ', varp(:,2)
                          WRITE(38,313) '  lambda1 ', varp(:,3)
                          WRITE(38,313) '  lambda2 ', varp(:,4)
                          
                          NN=(SIZE(typeno)+1)*2
                          ALLOCATE(xcon(NN))
                          
                          xcon=0.0_dp
                          xcon(1)=x(1)
                          xcon(2)=x(2)
                          j=2                       
                          DO k=1, SIZE(typeno)
                             DO i=1, 5
                                IF ( i .EQ. typeno(k) ) THEN
                                   SELECT CASE ( i )
                                   CASE (1)
                                      j=j+1
                                      xcon(j)=(x(3)-1.0_dp)/(2.0_dp*x(3))
                                      j=j+1
                                      xcon(j)=(x(4)-1.0_dp)/(2.0_dp*x(4))
                                   CASE (2)
                                      j=j+1
                                      xcon(j)=(x(3)-1.0_dp)/(2.0_dp*x(3)+2.0_dp)
                                      j=j+1
                                      xcon(j)=(x(4)-1.0_dp)/(2.0_dp*x(4)+2.0_dp)
                                   CASE (3)
                                      j=j+1
                                      xcon(j)=(3.0_dp*x(3)-3.0_dp)/(4.0_dp*x(3)+12.0_dp)
                                      j=j+1
                                      xcon(j)=(3.0_dp*x(4)-3.0_dp)/(4.0_dp*x(4)+12.0_dp)
                                   CASE (4)
                                      j=j+1
                                      xcon(j)=(x(3)-1.0_dp)/(2.0_dp*x(3)+2.0_dp)
                                      j=j+1
                                      xcon(j)=(x(4)-1.0_dp)/(2.0_dp*x(4)+2.0_dp)
                                   CASE (5)
                                      j=j+1
                                      xcon(j)=(x(3)-1.0_dp)/(2.0_dp*x(3)+2.0_dp)
                                      j=j+1
                                      xcon(j)=(x(4)-1.0_dp)/(2.0_dp*x(4)+2.0_dp)
                                   END SELECT
                                END IF
                             END DO
                          END DO
                          CALL fcns (NN, xcon, arpno, IBDSnn, relnn, eps, familynn, familynn(arpno),  &
                               &  nlocation, n_location, TT, typeno, SIZE(typeno) )
                          DEALLOCATE(xcon)
                          WRITE(*,'(/,A,1X,F7.3,2X,A,I3)') ' Score statistic for testing homogeneity =', TT,  &
                               &  'with df =', (SIZE(typeno)-1)*2
                          WRITE(38,'(/,A,1X,F7.3,2X,A,I3)') ' Score statistic for testing homogeneity =', TT,  &
                               &  'with df =', (SIZE(typeno)-1)*2
!                          WRITE(65,'(F12.8)') TT
                          EXIT
                       ELSE
                          WRITE(*,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(38,'(/,A)') ' The estimating equation cannot be solved in the reasonable parameter space !'
                          WRITE(*,'(A)') ' No two disease genes or too poor initial values !'
                          WRITE(38,'(A)') ' No two disease genes or too poor initial values !'
                          GO TO 88
                       END IF
                    ELSE
                       iter=iter+1           
                       IF ( iter>maxiter ) THEN
                          WRITE(*,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          WRITE(38,'(/,A,2X,I3,2X,A)') ' Not converge in', maxiter, 'iterations !'
                          GO TO 88
                       END IF
                       oldx2 = oldx1
                       oldx1 = x(1)
                       IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)*0.5
                          END DO
                       ELSE
                          DO i=1, NN
                             x(i)=x(i)+IinvU(i)
                          END DO
                       END IF
                       DO i=1, NN
                          IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) THEN
                             WRITE(*,'(/,A)') ' No two disease genes or too poor initial values !'
                             WRITE(38,'(/,A)') ' No two disease genes or too poor initial values !'
                             GO TO 88                          
                          END IF
                       END DO
                       fvec=0.0_dp
                       IinvU=0.0_dp
                       GO TO 97
                    END IF
                 END DO   ! END Fisher's scoring METHOD
                 
88               IF (BS .EQ. 'Y') THEN
                    WRITE(*,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    WRITE(38,'(/,A,/)') ' ============ Starting Bootstrap Method ============ '
                    NN=4
                    n=familynn(arpno)
                    kind=SIZE(typeno)
                    ALLOCATE(boot(n))
                    ALLOCATE(uuu(n))
                    ALLOCATE(point(NN,bootno))                    
                    bootco=1
                    DO 
                       IF (bootco>bootno) THEN
                          EXIT
                       END IF
                       WRITE(38,'(A,1X,I5,A)') ' ============ Bootstrap Sample', bootco, '   ============ '
467                    CALL RANDOM_SEED
                       CALL RANDOM_NUMBER(uuu) 
                       boot=CEILING(REAL(n)*uuu)
                       arpbo=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familynn(j) .EQ. boot(i) ) THEN
                                arpbo=arpbo+1
                             END IF
                          END DO
                       END DO
                       ALLOCATE(IBDSb(n_location,arpbo))
                       ALLOCATE(relb(arpbo))
                       ALLOCATE(familyb(arpbo))
                       ALLOCATE(nfamilyb(arpbo))
                       k=0
                       DO i=1, n
                          DO j=1, arpno
                             IF ( familynn(j) .EQ. boot(i) ) THEN
                                k=k+1
                                IBDSb(:,k)=IBDSnn(:,j)
                                relb(k)=relnn(j)
                                familyb(k)=familynn(j)   
                                nfamilyb(k)=i
                             END IF
                          END DO
                       END DO
                       x(1:2) = xini(1:2)
                       x(3:NN) = 1.0_dp/(1.0_dp-2.0_dp*xini(3))
                       oldx2 = 0.0_dp
                       oldx1 = 0.0_dp
                       DO       ! START Fisher's scoring METHOD
                          iter=0
367                       CALL fcnc (NN, x, fvec, arpbo, IBDSb, relb, eps, IinvU, nfamilyb, n,  &
                               nlocation, n_location, varp, typeno, SIZE(typeno) )
                          
                          sta=0.0_dp
                          DO i=1, NN
                             sta=sta+abs(fvec(i))
                          END DO
                          
                          WRITE(38,213) 'bootco=', bootco, 'iter=', iter, 'x=', x(1)*100.0_dp, x(2)*100.0_dp, x(3:NN), 'sta=', sta
                          
                          IF(sta .LT. tolimit) THEN
                             cou=0
                             DO i=1, NN
                                IF ( ( x(i) .GT. bound(i,1) ) .AND. ( x(i) .LT. bound(i,2) ) ) THEN
                                   cou=cou+1
                                ELSE 
                                   cou=cou
                                END IF
                             END DO
                             IF ( cou .EQ. NN ) THEN
                                point(1:NN,bootco)=x(1:NN)
                                WRITE(77,'(4F12.8)') x
                                bootco=bootco+1
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                EXIT
                             ELSE
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 467
                             END IF
                          ELSE
                             iter=iter+1           
                             IF ( iter>maxiter ) THEN
                                DEALLOCATE(IBDSb)
                                DEALLOCATE(relb)
                                DEALLOCATE(familyb)
                                DEALLOCATE(nfamilyb)
                                GO TO 467
                             END IF
                             oldx2 = oldx1
                             oldx1 = x(1)
                             IF ( (ABS(x(1)+IinvU(1)-oldx2) .LE. eps2) .AND. (ABS(x(1)+IinvU(1)-oldx1) .GE. eps2) ) THEN
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)*0.5
                                END DO
                             ELSE
                                DO i=1, NN
                                   x(i)=x(i)+IinvU(i)
                                END DO
                             END IF
                             DO i=1, NN
                                IF ( ((x(i)+IinvU(i)) .GT. x_upper(i)*100.0_dp) .OR. ((x(i)+IinvU(i)) .LT. x_lower(i)*100.0_dp) ) &
                                     &  THEN
                                   DEALLOCATE(IBDSb)
                                   DEALLOCATE(relb)
                                   DEALLOCATE(familyb)
                                   DEALLOCATE(nfamilyb)
                                   GO TO 467                         
                                END IF
                             END DO
                             fvec=0.0_dp
                             IinvU=0.0_dp
                             GO TO 367
                          END IF
                       END DO   ! END Fisher's scoring METHOD
                    END DO   ! End bootstrap loop
                    ! Summarize the bootstrap results
                    ALLOCATE(avexb(NN))
                    ALLOCATE(temppoint(NN,bootno))
                    ALLOCATE(bootCI(NN,2))
                    DO i=1, NN
                       avexb(i)=SUM(point(i,1:bootno))/REAL(bootno)
                    END DO
                    
                    ! Sorting 
                    
                    DO i=1, NN
                       temppoint(i,1:bootno)=point(i,1:bootno)
                       DO j=1, (bootno-1)
                          tp=MINVAL(temppoint(i,j:bootno))
                          temploc=MINLOC(temppoint(i,j:bootno))+j-1   ! Notice that temploc is an one-element array
                          temppoint(i,temploc)=temppoint(i,j)         ! Here you cannot add the subscript on temploc
                          temppoint(i,j)=tp
                       END DO
                    END DO
                    
                    DO i=1, NN
                       bootCI(i,1)=temppoint(i,CEILING(bootno*0.025_dp))
                       bootCI(i,2)=temppoint(i,FLOOR(bootno*0.975_dp))
                    END DO
                    
                    WRITE(*,'(A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from', bootno, &
                         &              ' bootstrap samples :'
                    
                    WRITE(*,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,701) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(*,800) ' Common risk ratio lambda1 =', avexb(3),  &
                         &  '(', MAX(0.0_dp,bootCI(3,1)), '-', bootCI(3,2), ')'  
                    WRITE(*,800) ' Common risk ratio lambda2 =', avexb(4),  &
                         &  '(', MAX(0.0_dp,bootCI(4,1)), '-', bootCI(4,2), ')'  

                    
                    WRITE(38,'(/,A,I5,A)') ' Bootstrap point estimates (by Mean) and 95% bootstrap CI (by Percentile) from',bootno,&
                         &              ' bootstrap samples :'
                    
                    WRITE(38,700) ' Location for tau1  =', avexb(1)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(1,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(1,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Location for tau2  =', avexb(2)*100.0_dp,  &
                         &  '(', MAX(0.0_dp,bootCI(2,1)*100.0_dp), '-',  &
                         &       MIN(bootCI(2,2)*100.0_dp,nlocation(n_location)*100.0_dp), ') cM.'
                    WRITE(38,800) ' Common risk ratio lambda1 =', avexb(3),  &
                         &  '(', MAX(0.0_dp,bootCI(3,1)), '-', bootCI(3,2), ')'  
                    WRITE(38,800) ' Common risk ratio lambda2 =', avexb(4),  &
                         &  '(', MAX(0.0_dp,bootCI(4,1)), '-', bootCI(4,2), ')'  


!!!!!!
!                    WRITE(76,'(4F12.8)') avexb
!                    WRITE(78,'(4F12.8)') bootCI(1,1)*100.0_dp, bootCI(1,2)*100.0_dp, bootCI(2,1)*100.0_dp, bootCI(2,2)*100.0_dp
                    
                    DEALLOCATE(avexb)
                    DEALLOCATE(temppoint)
                    DEALLOCATE(bootCI)
                    DEALLOCATE(boot)
                    DEALLOCATE(uuu)
                    DEALLOCATE(point)
                    
                 END IF

                 DEALLOCATE(x)
                 DEALLOCATE(fvec)
                 DEALLOCATE(IinvU)
                 DEALLOCATE(varp)
                 DEALLOCATE(se)
                 DEALLOCATE(bound)
                 DEALLOCATE(x_lower)
                 DEALLOCATE(x_upper)  

              END IF


              DEALLOCATE(IBDSnn)
              DEALLOCATE(relnn)
              DEALLOCATE(familynntmp)
              DEALLOCATE(familynn)


           ELSE IF (SUM(typereln) .LT. 15) THEN
              WRITE(*,'(/,A,/)') ' ===   Unconstrained and constrained-Model Approach analysis result   ==='
              WRITE(*,'(/,A)') ' The number of ARPs is under 15, skip unconstrained and constrained-model approach analysis !'
              WRITE(38,'(/,A,/)') ' ===   Unconstrained and constrained-Model Approach analysis result   ==='
              WRITE(38,'(/,A)') ' The number of ARPs is under 15, skip unconstrained and constrained-model approach analysis !'
           END IF

        END IF
        
     END IF
     ini = ini +1
     
  END DO

  WRITE(*,'(/,1X,A)') ' Iteration records were stored in file [Iter]'

  WRITE(*,'(/,/,1X,A)') ' Thanks for your look into the software.'
  WRITE(*,*) ' If this software is helpful to your research, please cite:'
  WRITE(*,*) ' Robust Multipoint Simultaneous Identical-by-Descent Mapping for'
  WRITE(*,*) ' Two Linked Loci. by Wan-Yu Lin and Daniel J. Schaid.'
  WRITE(*,'(A,/,/)') '  '



  WRITE(38,'(/,/,1X,A)') ' Thanks for your look into the software.'
  WRITE(38,*) ' If this software is helpful to your research, please cite:'
  WRITE(38,*) ' Robust Multipoint Simultaneous Identical-by-Descent Mapping for'
  WRITE(38,*) ' Two Linked Loci.   by Wan-Yu Lin and Daniel J. Schaid.'
  WRITE(38,'(A,/,/)') '  '
  


  1 FORMAT (4X, F7.3, 2X, 2(F7.3, 2X))
  2 FORMAT (4X, F7.3, 2X, 3(F7.3, 2X))
  3 FORMAT (4X, F7.3, 2X, 4(F7.3, 2X))
  4 FORMAT (4X, F7.3, 2X, 5(F7.3, 2X))
  5 FORMAT (4X, F7.3, 2X, 6(F7.3, 2X))
700 FORMAT (/,A,1X,F7.3,2X,A,F7.3,2X,A,1X,F7.3,2X,A)
701 FORMAT (A,1X,F7.3,2X,A,F7.3,2X,A,1X,F7.3,2X,A)
800 FORMAT (A,1X,F7.3,2X,A,F10.3,2X,A,F10.3,2X,A)
108 FORMAT (A,I4,2X,A,2F16.8,4X,A,2X,F16.7)
112 FORMAT (A,I4,2X,A,3F16.8,4X,A,2X,F16.7)
113 FORMAT (A,I4,2X,A,4F16.8,4X,A,2X,F16.7)
114 FORMAT (A,I4,2X,A,5F16.8,4X,A,2X,F16.7)
115 FORMAT (A,I4,2X,A,6F16.8,4X,A,2X,F16.7)
116 FORMAT (A,I4,2X,A,8F16.8,4X,A,2X,F16.7)
117 FORMAT (A,I4,2X,A,10F16.8,4X,A,2X,F16.7)
118 FORMAT (A,I4,2X,A,12F16.8,4X,A,2X,F16.7)
! Below are for bootstrap:
208 FORMAT (A,I5,2X,A,I4,2X,A,2F16.8,4X,A,2X,F16.7)
212 FORMAT (A,I5,2X,A,I4,2X,A,3F16.8,4X,A,2X,F16.7)
213 FORMAT (A,I5,2X,A,I4,2X,A,4F16.8,4X,A,2X,F16.7)
214 FORMAT (A,I5,2X,A,I4,2X,A,5F16.8,4X,A,2X,F16.7)
215 FORMAT (A,I5,2X,A,I4,2X,A,6F16.8,4X,A,2X,F16.7)
216 FORMAT (A,I5,2X,A,I4,2X,A,8F16.8,4X,A,2X,F16.7)
217 FORMAT (A,I5,2X,A,I4,2X,A,10F16.8,4X,A,2X,F16.7)
218 FORMAT (A,I5,2X,A,I4,2X,A,12F16.8,4X,A,2X,F16.7)
! Below are for robust variance estimate:
308 FORMAT (A,2F12.8)
312 FORMAT (A,3F12.8)
313 FORMAT (A,4F12.8)
314 FORMAT (A,5F12.8)
315 FORMAT (A,6F12.8)
316 FORMAT (A,8F12.8)
317 FORMAT (A,10F12.8)
318 FORMAT (A,12F12.8)           

  STOP
  
END PROGRAM arp



